// ============================================================
// Project				:	peopleRP
// Author				:	Jookia & Faggot
// Description			:	Civilian Code file
// ============================================================
// Table of Contents
// 1. Handling Script Start
// 2. Lots
// 3. Data Bricks
// 4. Spawns
// 5. Resources
// 5. Other
// ============================================================

// ============================================================
// Section 1 : Handling Script Start
// ============================================================

%error = forceRequiredAddOn("player_no_jet");

if(%error)
{
	if(%error == $error::addOn_disabled)
	{
		playerNoJet.uiName = "";
	}
	
	if(%error == $error::addOn_notFound)
	{
		return;
	}
}

$CityRP::loadedDatablocks = true;

if(!$CityRP::loadedDatablocks)
{
	return;
}

datablock triggerData(CityRPLotTriggerData)
{
	tickPeriodMS = 500;
	
	parent = 0;
};

datablock triggerData(CityRPInputTriggerData)
{
	tickPeriodMS = 500;
	
	parent = 0;
};


// ============================================================
// Section 2 : Lots
// ============================================================

datablock fxDTSBrickData(CityRPSmallLotBrickData : brick16x16FData)
{
	category = "CityRP";
	subCategory = "CityRPG Lots";
	
	uiName = "Small Lot";
	
	CityRPBrickType = 1;
	CityRPBrickAdmin = false;
	
	triggerDatablock = CityRPLotTriggerData;
	triggerSize = "16 16 32";
	trigger = 0;
	
	initialPrice = 25;
	taxAmount = 15;
};

datablock fxDTSBrickData(CityRPHalfSmallLotBrickData : brick16x32FData)
{
	category = "CityRP";
	subCategory = "CityRPG Lots";
	
	uiName = "Half-Small Lot";
	
	CityRPBrickType = 1;
	CityRPBrickAdmin = false;
	
	triggerDatablock = CityRPLotTriggerData;
	triggerSize = "16 32 32";
	trigger = 0;
	
	initialPrice = 35;
	taxAmount = 20;
};

datablock fxDTSBrickData(CityRPMediumLotBrickData : brick32x32FData)
{
	category = "CityRP";
	subCategory = "CityRPG Lots";
	
	uiName = "Medium Lot";
	
	CityRPBrickType = 1;
	CityRPBrickAdmin = false;
	
	triggerDatablock = CityRPLotTriggerData;
	triggerSize = "32 32 64";
	trigger = 0;
	
	initialPrice = 50;
	taxAmount = 25;
};

datablock fxDTSBrickData(CityRPLargeLotBrickData : brick64x64FData)
{
	category = "CityRP";
	subCategory = "CityRPG Lots";
	
	uiName = "Large Lot";
	
	CityRPBrickType = 1;
	CityRPBrickAdmin = false;
	
	triggerDatablock = CityRPLotTriggerData;
	triggerSize = "64 64 128";
	trigger = 0;
	
	initialPrice = 100;
	taxAmount = 50;
};

// ============================================================
// Section 3 : Data Bricks
// ============================================================
echo("Launching Bricks :: Info Bricks");
for(%brickCount = 1; isFile("./bricks/info/" @ %brickCount @ ".cs"); %brickCount++)
{
	exec("./bricks/info/" @ %brickCount @ ".cs");	
}

// ============================================================
// Section 4 : Spawns
// ============================================================

datablock fxDtsBrickData(CityRPPersonalSpawnBrickData : brickSpawnPointData)
{
	category = "CityRP";
	subCategory = "CityRPG Spawns";
	
	uiName = "Personal Spawn";
	
	specialBrickType = "";
	
	CityRPBrickType = 3;
	CityRPBrickAdmin = false;
	
	spawnData = "personalSpawn";
};

datablock fxDtsBrickData(CityRPJailSpawnBrickData : brickSpawnPointData)
{
	category = "CityRP";
	subCategory = "CityRPG Spawns";
	
	uiName = "Jail Spawn";
	
	specialBrickType = "";
	
	CityRPBrickType = 3;
	CityRPBrickAdmin = true;
	
	spawnData = "jailSpawn";
};

// ============================================================
// Section 5 : Resources
// ============================================================
echo("Launching Bricks :: Resources");
for(%i = 1; isFile("./bricks/resources/" @ %i @ ".cs"); %i++)
{
		exec("./bricks/resources/" @ %i @ ".cs");	
}

// ============================================================
// Section 6 : Other
// ============================================================
datablock fxDTSBrickData(CityRPPermaSpawnData : brick2x2FData)
{
	category = "CityRP";
	subCategory = "CityRPG Infoblocks";
	
	uiName = "Permaspawn Brick";

	CityRPBrickAdmin = true;
	CityRPPermaspawn = 1;
};