// ============================================================
// Project				:	CityRPG
// Author				:	Iban & Jookia
// Description			:	Bank Brick Code File
// ============================================================
// Table of Contents
// 1. Brick Data
// 2. Trigger Data
// ============================================================

// ============================================================
// Section 1 : Brick Data
// ============================================================
datablock fxDTSBrickData(CityRPBankBrickData : brick2x4FData)
{
	category = "IbanMods";
	subCategory = "CityRPG Infoblocks";
	
	uiName = "Bank Brick";
	
	CityRPBrickType = 2;
	CityRPBrickAdmin = true;
	
	triggerDatablock = CityRPInputTriggerData;
	triggerSize = "2 4 1";
	trigger = 0;
};

// ============================================================
// Section 2 : Trigger Data
// ============================================================
function CityRPBankBrickData::parseData(%this, %brick, %client, %triggerStatus, %text)
{
	if(%triggerStatus !$= "")
	{
		if(%triggerStatus == true && %client.stage $= "")
		{
			messageClient(%client, '', "\c6Welcome! Please type the number corresponding to the options below.");
			if(CityRPData.getData(%client.bl_id).valueBank > 0)
			{
				messageClient(%client, '', "\c6- You have \c3$" @ CityRPData.getData(%client.bl_id).valueBank SPC "\c6in the bank.");
			}
			if(CityRPData.getData(%client.bl_id).valueDebt > 0)
			{
				messageClient(%client, '', '\c6- You also have \c0$%1\c6 in debt.', CityRPData.getData(%client.bl_id).valueDebt);
			}
			
			messageClient(%client, '', "\c31 \c6- Withdraw money.");
			messageClient(%client, '', "\c32 \c6- Deposit money.");
			messageClient(%client, '', "\c33 \c6- Deposit all money.");
			messageClient(%client, '', '\c34 \c6- Pay off debt. (\c3$%1\c6/\c0$%2\c6)', (!CityRPData.getData(%client.bl_id).valueDebt ? 0 : (CityRPData.getData(%client.bl_id).valueMoney > CityRPData.getData(%client.bl_id).valueDebt ? CityRPData.getData(%client.bl_id).valueDebt : CityRPData.getData(%client.bl_id).valueMoney)), CityRPData.getData(%client.bl_id).valueDebt);
						
			%client.stage = 0;
		}
		
		if(%triggerStatus == false && %client.stage !$= "")
		{
			messageClient(%client, '', "\c6Thanks, come again.");
			
			%client.stage = "";
		}
		
		return;
	}
	
	%input = strLwr(%text);
	
	if(mFloor(%client.stage) == 0)
	{
		if(strReplace(%input, "1", "") !$= %input || strReplace(%input, "one", "") !$= %input)
		{
			%client.stage = 1.1;
			
			messageClient(%client, '', "\c6Please enter the amount of money you wish to withdraw.");
			
			return;
		}
		
		if(strReplace(%input, "2", "") !$= %input || strReplace(%input, "two", "") !$= %input)
		{
			%client.stage = 1.2;
			
			messageClient(%client, '', "\c6Please enter the amount of money you wish to deposit.");
			
			return;
		}
		
		if(strReplace(%input, "3", "") !$= %input || strReplace(%input, "three", "") !$= %input)
		{
			%client.stage = 1.2;
			
			serverCmdMessageSent(%client, CityRPData.getData(%client.bl_id).valueMoney);
			
			return;
		}
		if(strReplace(%input, "4", "") !$= %input || strReplace(%input, "four", "") !$= %input)
		{
			%client.stage = 1.3;
			
			serverCmdMessageSent(%client, "");
			
			return;
		}
		
		messageClient(%client, '', "\c3" @ %text SPC "\c6is not a valid option!");
		
		return;
	}
	
	if(mFloor(%client.stage) == 1)
	{
		if(%client.stage == 1.1)
		{
			if(mFloor(%input) < 1)
			{
				messageClient(%client, '', "\c6Please enter a valid amount of money to withdraw.");
				
				return;
			}
			
			if(CityRPData.getData(%client.bl_id).valueBank - mFloor(%input) < 0)
			{
				if(CityRPData.getData(%client.bl_id).valueBank < 1)
				{
					messageClient(%client, '', "\c6You don't have that much money in the bank to withdraw.");
					
					%brick.trigger.getDatablock().onLeaveTrigger(%brick.trigger, (isObject(%client.player) ? %client.player : 0));
					
					return;
				}
				
				%input = CityRPData.getData(%client.bl_id).valueBank;
			}
			
			messageClient(%client, '', "\c6You have withdrawn \c3$" @ mFloor(%input) @ "\c6.");
			
			%brick.trigger.getDatablock().onLeaveTrigger(%brick.trigger, (isObject(%client.player) ? %client.player : 0));
			
			CityRPData.getData(%client.bl_id).valueBank -= mFloor(%input);
			CityRPData.getData(%client.bl_id).valueMoney += mFloor(%input);
			
			%client.SetInfo();
		}
		
		if(%client.stage == 1.2)
		{
			if(mFloor(%input) < 1)
			{
				messageClient(%client, '', "\c6Please enter a valid amount of money to deposit.");
				
				return;
			}
			
			if(CityRPData.getData(%client.bl_id).valueMoney - mFloor(%input) < 0)
			{
				if(CityRPData.getData(%client.bl_id).valueMoney < 1)
				{
					messageClient(%client, '', "\c6You don't have that much money to deposit.");
					
					%brick.trigger.getDatablock().onLeaveTrigger(%brick.trigger, (isObject(%client.player) ? %client.player : 0));
					
					return;
				}
				
				%input = CityRPData.getData(%client.bl_id).valueMoney;
			}
			
			messageClient(%client, '', "\c6You have deposited \c3$" @ mFloor(%input) @ "\c6!");
			
			%brick.trigger.getDatablock().onLeaveTrigger(%brick.trigger, (isObject(%client.player) ? %client.player : 0));
			
			CityRPData.getData(%client.bl_id).valueBank += mFloor(%input);
			CityRPData.getData(%client.bl_id).valueMoney -= mFloor(%input);
			
			%client.SetInfo();
		}
		
		if(%client.stage == 1.3)
		{
			if(CityRPData.getData(%client.bl_id).valueDebt <= 0)
			{
				messageClient(%client, '', "\c6You have no money to pay off.");
				
				%brick.trigger.getDatablock().onLeaveTrigger(%brick.trigger, (isObject(%client.player) ? %client.player : 0));
				
				return;
			}
			
			if(CityRPData.getData(%client.bl_id).valueMoney <= 0)
			{
				messageClient(%client, '', "\c6You don't have any money to pay off debt with.");
				%brick.trigger.getDatablock().onLeaveTrigger(%brick.trigger, (isObject(%client.player) ? %client.player : 0));
				
				return;
			}
			
			%money = CityRPData.getData(%client.bl_id).valueMoney;
			%oldDebt = CityRPData.getData(%client.bl_id).valueDebt;
			CityRPData.getData(%client.bl_id).valueDebt -= (%money >= %oldDebt ? %oldDebt : %money);
			CityRPData.getData(%client.bl_id).valueMoney = (%money - %oldDebt > 0 ? %money - %oldDebt : 0);
			%debt = CityRPData.getData(%client.bl_id).valueDebt;			
			
			if(%debt)
			{
				messageClient(%client, '', '\c6You have paid \c3$%1\c6 towards your debt and have \c0$%2\c6 left.', %money, %debt);
			}
			else
			{
				messageClient(%client, '', '\c6After paying \c3$%1\c6, you are now debt free!', %money);
			}
			
			%client.SetInfo();
		}
		
		return;
	}
}