// ============================================================
// Project				:	peopleRP
// Author				:	Iban
// Description			:	Tree Resource Code File
// ============================================================
// Table of Contents
// 1. Brick Data
// 2. Events
// 3. Package Data
// ============================================================

// ============================================================
// Section 1 : Brick Data
// ============================================================
datablock fxDTSBrickData(CityRPTreeData : brickPineTreeData)
{
	category = "IbanMods";
	subCategory = "CityRPG Resources";
	
	uiName = "Lumber Tree";
	
	resources = 50;
	
	CityRPBrickType = 4;
	CityRPBrickAdmin = true;
};

// ============================================================
// Section 2 : Events
// ============================================================
function fxDTSBrick::onCut(%this, %client)
{
	if(getWord(CityRPData.getData(%client.bl_id).valueJailData, 1) > 0 || $CityRP::jobs::labor[CityRPData.getData(%client.bl_id).valueJobID])
	{
		if(%this.resources > 0)
		{
			if(mFloor(getRandom(0, 100)) >= 90)
			{
				commandToClient(%client, 'centerPrint' , "\c6Lumber obtained.", 1);
				CityRPData.getData(%client.bl_id).valueResources = (getWord(CityRPData.getData(%client.bl_id).valueResources, 0) + 1) SPC getWord(CityRPData.getData(%client.bl_id).valueResources, 1);
				
				%client.SetInfo();
			}
		}
	}
	else
	{
		commandToClient(%client, 'centerPrint', "\c6You're a free man, why labor any longer?", 3);
	}
}

// ============================================================
// Section 3 : Package Data
// ============================================================
package CityRP_LumberjackPackage
{
	function ProjectileData::onCollision(%this, %obj, %col, %fade, %pos, %normal)
	{
		parent::onCollision(%this, %obj, %col, %fade, %pos, %normal);
		
		if(isObject(%col))
		{
			if(%col.getType() & $TypeMasks::FxBrickObjectType)
			{
				if(%col.getDatablock().getName() $= "CityRPTreeData")
				{
					if(%obj.getDatablock().getName() $= "CityRPLumberjackProjectile")
					{
						%col.onCut(%obj.sourceObject.client);
					}
				}
			}
		}
	}
};
activatePackage(CityRP_LumberjackPackage);