// ============================================================
// Project				:	CityRPG
// Author				:	Iban
// Description			:	Ore Brick Code File
// ============================================================
// Table of Contents
// 1. Brick Data
// 2. Events
// 3. Package Data
// ============================================================

// ============================================================
// Section 1 : Brick Data
// ============================================================
datablock fxDTSBrickData(CityRPOreData)
{
	brickFile = "Add-Ons/GameMode_CityRPG/shapes/4x Cube.blb";
	iconName = "Add-Ons/GameMode_CityRPG/shapes/BrickIcons/4x Cube";
	
	category = "IbanMods";
	subCategory = "CityRPG Resources";
	
	uiName = "Ore";
	
	isRock = 1;
	hasOre = 1;
	resources = 15;
	
	CityRPBrickType = 4;
	CityRPBrickAdmin = true;
};

// ============================================================
// Section 2 : Events
// ============================================================
function fxDTSBrick::onMine(%this, %client)
{
	if(isObject(%this) && isObject(%client))
	{
		if(getWord(CityRPData.getData(%client.bl_id).valueJailData, 1) > 0 || $CityRP::jobs::labor[CityRPData.getData(%client.bl_id).valueJobID])
		{
			if(%this.hasOre && %this.resources == 0)
			{
				%this.resources = %this.getDatablock().resources;
			}
			
			if(%this.resources > 0)
			{
				%this.hasOre = true;
				if(mFloor(getRandom(0, 100)) >= 90)
				{
					%this.resources--;
					if(!%this.resources)
					{
						commandToClient(%client, 'centerPrint' , "\c6You have emptied this rock of its resources!", 1);
						%this.adjustColorOnOreContent();
					}
					else
					{
						commandToClient(%client, 'centerPrint' , "\c6Minerals obtained.", 1);
					}
					
					
					CityRPData.getData(%client.bl_id).valueResources = getWord(CityRPData.getData(%client.bl_id).valueResources, 0) SPC (getWord(CityRPData.getData(%client.bl_id).valueResources, 1) + 1);
					%client.SetInfo();
				}
			}
		}
		else
		{
			commandToClient(%client, 'centerPrint', "\c6You're a free man, why labor any longer?", 3);
		}
	}
}
function fxDTSBrick::adjustColorOnOreContent(%this)
{
	if(isObject(%this))
	{
		if(%this.getDatablock().isRock && %this.getDatablock().CityRPBrickType == 4)
		{
			%this.hasOre = !%this.hasOre;
			%this.setColor(0);
			
			if(!%this.hasOre)
			{
				%this.schedule(getRandom(60000, 120000), "adjustColorOnOreContent");
			}
		}
	}
}

// ============================================================
// Section 3 : Package Data
// ============================================================
package CityRP_OrePackage
{
	function ProjectileData::onCollision(%this, %obj, %col, %fade, %pos, %normal)
	{
		parent::onCollision(%this, %obj, %col, %fade, %pos, %normal);
		
		if(isObject(%col))
		{
			if(%col.getType() & $TypeMasks::FxBrickObjectType)
			{
				if(%col.getDatablock().getName() $= "CityRPOreData")
				{
					if(%obj.getDatablock().getName() $= "CityRPShovelProjectile")
					{
						%col.onMine(%obj.sourceObject.client);
					}
				}
			}
		}
	}
	
	// Section 2.1 : Overrides
	function fxDTSBrick::onPlant(%brick)
	{	
		parent::onPlant(%brick);
		
		if(%brick.getDatablock().hasOre && %brick.getDatablock().CityRPBrickType == 4)
		{
			%brick.hasOre = true;
			%brick.setColor(0);
		}
	}
	
	function fxDTSBrick::setColor(%this, %color)
	{
		if(%this.getDataBlock().isRock)
		{
			if(!%this.hasOre)
			{
				parent::setColor(%this, $CityRP::pref::resources::ore::noOreColorID);
			}
			else
			{
				parent::setColor(%this, $CityRP::pref::resources::ore::hasOreColorID);
			}
		}
		else
		{
			parent::setColor(%this, %color);
		}
	}
	
	function fxDTSBrick::setColorFX(%this, %FX)
	{
		if(!%this.getDataBlock().isRock)
		{
			parent::setColorFX(%this, %FX);
		}
	}
	
	function fxDTSBrick::setShapeFX(%this, %FX)
	{
		if(!%this.getDataBlock().isRock)
		{
			parent::setShapeFX(%this, %FX);
		}
	}
	
	function fxDTSBrick::setEmitter(%this, %emitter)
	{
		if(!%this.getDataBlock().isRock)
		{
			parent::setEmitter(%this, %emitter);
		}
	}
};
activatePackage(CityRP_OrePackage);