// ============================================================
// Project				:	CityRP
// Author				:	Jookia & Iban
// Description			:	Code used by all walks of life.
// ============================================================
// Table of Contents
// 1. Game CityRP Functions
// 2. Brick CityRP Functions
// 3. Client CityRP Functions
// 4. Trigger Bullshit
// 5. CrpCmds
// 6. Misc. Shit Functions
// ============================================================

// ============================================================
// Section 1 : Game CityRP Functions
// ============================================================
function CityRP_BootUp()
{
	if(!isObject(CityRPData))
		{
			new scriptObject(CityRPData)
			{
				class = Sassy;
				dataFile = "config/server/IbanMod/CityRPG/Data.dat";
			};
			
			if(!isFile("config/server/IbanMod/CityRPG/Prefs.cs"))
			{
				exec("./prefs.cs");
			}
			
			exec("config/server/IbanMod/CityRPG/Prefs.cs");
			deleteVariables("$CityRP::temp::*");
			
			if(!CityRPData.loadedSaveFile)
			{
				CityRPData.addValue("money", 0);
				CityRPData.addValue("bank", $CityRP::pref::players::startingCash + 400);
				CityRPData.addValue("tools", "");
				CityRPData.addValue("jobID", 1);
				CityRPData.addValue("demerits", 0);
				CityRPData.addValue("jailData", "0 0");
				CityRPData.addValue("bounty", 0);
				CityRPData.addValue("debt", $CityRP::pref::players::sdtartingCash);
				CityRPData.addValue("resources", "0 0");
				CityRPData.addValue("lotData", "0");
				CityRPData.addValue("exp", "0");
			}
			else
			{
				for(%a = 1; %a <= CityRPData.dataCount; %a++)
				{
						if(CityRPData.data[%a].valueJobID > $CityRP::jobs || CityRPData.data[%a].valueJobID < 0)
					{
						CityRPData.data[%a].valueJobID = 1;
					}
				}
			}
			
			registerInputEvent("fxDTSBrick", "onEnterLot", "Self fxDTSBrick\tPlayer player\tClient gameConnection\tMiniGame miniGame");
			registerInputEvent("fxDTSBrick", "onLeaveLot", "Self fxDTSBrick\tPlayer player\tClient gameConnection\tMiniGame miniGame");
			registerInputEvent("fxDTSBrick", "onTransferSuccess", "Self fxDTSBrick\tPlayer Player\tClient GameConnection");
			registerInputEvent("fxDTSBrick", "onTransferDecline", "Self fxDTSBrick\tPlayer Player\tClient GameConnection");
			registerInputEvent("fxDTSBrick", "onVehicleDestroyed", "Self fxDTSBrick");
			registerOutputEvent("GameConnection", "requestFunds", "string 80 200\tint 1 9999", 0);
			
			CityRPData.tickCount = 0;
				
			CityRPData.scheduleTick = schedule($CityRP::tick::speed * 60000, false, "CityRP_Tick");
		}
		else
		{
			for(%a = 1; %a <= CityRPData.dataCount; %a++)
			{
				if(CityRPData.data[%a].valueJobID > $CityRP::jobs || CityRPData.data[%a].valueJobID < 0)
				{
					CityRPData.data[%a].valueJobID = 1;
				}
			}
		}
		
		if(!isObject(CityRPHelp))
		{
			new scriptObject(CityRPHelp)
			{
				class = Hellen;
			};
		}
		
		if(!isObject(CityRPMini))
		{
			CityRP_BuildMinigame();
		}
}

function CityRP_BuildMinigame()
{
	echo("CityRP :: Creating Minigame");
	for(%i = 0;%i < ClientGroup.getCount();%i++)
	{
		%subClient = ClientGroup.getObject(%i);
		%subClient.minigame = NULL;
	}
	
	echo("CityRP :: Minigame :: Deleting Minigame");
	if(isObject(CityRPMini))
	{
		CityRPMini.delete();
	}
	
	echo("CityRP :: Minigame :: Creating Minigame");
	new scriptObject(CityRPMini)
	{
		class = miniGameSO;
		
		brickDamage = true;
		brickRespawnTime = 10000;
		colorIdx = -1;
		
		enableBuilding = true;
		enablePainting = true;
		enableWand = true;
		fallingDamage = true;
		inviteOnly = true;
		
		points_plantBrick = 0;
		points_breakBrick = 0;
		points_die = -1;
		points_killPlayer = 1;
		points_killSelf = -1;
		
		playerDatablock = ($AddOn__Player_Health_Modes ? playerNoJetHealth : playerNoJet);
		respawnTime = 5000;
		selfDamage = true;
		
		playersUseOwnBricks = false;
		useAllPlayersBricks = true;
		useSpawnBricks = false;
		VehicleDamage = true;
		vehicleRespawnTime = 5000;
		weaponDamage = true;
		
		numMembers = 0;
	};
	
	echo("CityRP :: Minigame :: Populating Minigame");
	for(%i = 0;%i < ClientGroup.getCount();%i++)
	{
		%subClient = ClientGroup.getObject(%i);
		CityRPMini.addMember(%subClient);
	}
}

function CityRP_Tick()
{
	CityRP_BuildSpawns();
	if(CityRPData.scheduleTick)
	{
		cancel(CityRPData.scheduleTick);
	}
	
	CityRPData.tickCount++;
	
	for(%a = 0; %a <= CityRPData.dataCount; %a++)
	{
		if(CityRPData.tickCount % $CityRP::tick::interestTick == 0)
		{
			CityRPData.data[%a].valueBank = mFloor(CityRPData.data[%a].valueBank * $CityRP::tick::interest);
		}
		
		if(isObject(findClientByBL_ID(CityRPData.data[%a].ID)))
		{
			%client = findClientByBL_ID(CityRPData.data[%a].ID);
			if(getWord(CityRPData.getData(%client.bl_id).valueJailData, 1) > 0)
			{
				CityRPData.getData(%client.bl_id).valueJailData = 1 SPC getWord(CityRPData.getData(%client.bl_id).valueJailData, 1) - 1;
				
				if(getWord(CityRPData.getData(%client.bl_id).valueJailData, 1) < 1)
				{
					%client.CityRP(4);
					messageClient(%client, '', "\c6You're free.");
					
					if(isObject(%client.player))
					{
						%client.player.delete();
						%client.spawnPlayer();
					}
					
					continue;
				}
				
				messageClient(%client, '', "\c6You now have \c3" @ getWord(CityRPData.getData(%client.bl_id).valueJailData, 1) SPC "\c6tick" @ ((getWord(CityRPData.getData(%client.bl_id).valueJailData, 1) == 1) ? "" : "s") SPC "until you get out of jail.");
				
				continue;
			}
			
			if(CityRPData.getData(%client.bl_id).valueDemerits > 0)
			{
				if(CityRPData.getData(%client.bl_id).valueDemerits >= $CityRP::pref::demerits::reducePerTick)
				{
					CityRPData.getData(%client.bl_id).valueDemerits -= $CityRP::pref::demerits::reducePerTick;
				}
				else
				{
					CityRPData.getData(%client.bl_id).valueDemerits = 0;
				}
				
				messageClient(%client, '', "\c6Due to <a:en.wikipedia.org/wiki/Statute_of_limitations>Statute of Limitations</a>\c6, your demerits have been deducted to \c3" @ CityRPData.getData(%client.bl_id).valueDemerits @ "\c6.");
			}
			
			if($CityRP::jobs::pay[CityRPData.getData(%client.bl_id).valueJobID] > 0)
			{
				%sum = ($CityRP::jobs::pay[CityRPData.getData(%client.bl_id).valueJobID] - %client.brickGroup.taxes);
				
				if(%sum > 0)
				{
					CityRPData.getData(%client.bl_id).valueBank += %sum;
					messageClient(%client, '', "\c6Your paycheck of \c3$" @ %sum SPC "\c6has been deposited into your account.");
				}
				else if(%sum < 0)
				{
					CityRPData.getData(%client.bl_id).valueDebt -= %sum;
					messageClient(%client, '', "\c6Your debt has incresaed \c0$" @ %sum @ "\c6, and is now \c0$" @ CityRPData.getData(%client.bl_id).valueDebt @ "\c6.");
				}
			}
			
			if(CityRPData.getData(%client.bl_id).valueEXP < $CityRP::tick::promotionLevel)
			{
				CityRPData.getData(%client.bl_id).valueEXP++;
			}
			
			if(CityRPData.getData(%client.bl_id).valueDebt > 0)
			{
				messageClient(%client, '', "\c7You have \c31\c7 new message.");
				if(CityRPData.getData(%client.bl_id).valueDebt > 1000)
				{
					if(%client.ballBustingTime $= "")
					{
						messageClient(%client, '', '\c7Message\c6: I\'m not kidding anymore. \c0$%1\c6 ain\'t chump change! Pay this off in the next \c3%2\c6 ticks, or I\'m going to hurt you real, real, bad.', CityRPData.getData(%client.bl_id).valueDebt, $CityRP::pref::demerits::irsBustsYourBalls);
						%client.ballBustingTime = 3;
					}
					else if(%client.ballBustingTime !$= "" && %client.ballBustingTime > 1)
					{
						%client.ballBustingTime--;
						messageClient(%client, '', '\c7Cellphone\c6: Hey, Hey, Mr.\"I Ain\'t Go No Money!\" You better pay off at least \c0$%1\c6 in \c3%2\c6 ticks, or I\'m going to have you hunt down like the dog you are.', (CityRPData.getData(%client.bl_id).valueDebt - $CityRP::pref::demerits::irsBustsYourBalls), %client.ballBustingTime);
					}
					else
					{
						messageClient(%client, '', "\c7Cellphone\c6: Three strikes and you're outta here! I gave you enough time.");
						messageAll('', "\c3A Loan Shark\c6 has placed \c3$" @ $CityRP::pref::demerits::irsBounty @ "\c6 on \c3" @ %client.name @"\c6's head!");
						CityRPData.getData(%client.bl_id).valueDebt += $CityRP::pref::demerits::irsBounty;
						%client.ballBustingTime = 3;
					}
				}
			}
			
			
			%client.SetInfo();
			
			if(isObject(%client.player))
			{
				if(%client.player.lasPos $= %client.player.getPosition() && %client.player.lasPos)
				{
					%client.delete("Idle Player Kick");
					messageAll('', "\c2Idle Player Kicked");
				}
				else
				{
					%client.player.lasPos = %client.player.getPosition();
				}
			}
			else
			{
				if(%client.hasBeenDead == 1)
				{
					%client.delete("Idle Player Kick");
					messageAll('', "\c2Idle Player Kicked");
				}
				else
				{
					%client.hasBeenDead = 1;
				}
			}
		}
	}
	
	CityRPData.saveData();
	CityRPData.scheduleTick = schedule($CityRP::tick::speed * 60000, false, "CityRP_Tick");
}

function CityRP_BuildSpawns()
{
	echo("Recalculating Spawns..");
	$CityRP::temp::spawnPoints = NULL;
	for(%i = 0; %i<  mainBrickGroup.getCount(); %i++)
	{
		%brickGroup = mainBrickGroup.getObject(%i);
		for(%j = 0; %j< %brickGroup.getCount();%j++)
		{
			%brick = %brickGroup.getObject(%j);
			if(%brick.getDatablock().CityRPBrickType == 3)
			{
				$CityRP::temp::spawnPoints = (!$CityRP::temp::spawnPoints ? %brick : $CityRP::temp::spawnPoints SPC %brick);
			}
		}
	}
}

function CityRP_ItemPrice(%image)
{
	if($CityRP::prices::weapon::priceAlgorithm == false || $CityRP::prices::weapon[%image])
	{
		if($CityRP::prices::weapon[%image])
		{
			%price = $CityRP::prices::weapon[%image];
		}
		else
		{
			return 0;
		}
	}
	else
	{
		%price = (isObject(%image) && isObject(%image.projectile) ? mFloor(%image.projectile.directDamage) : 0) + $CityRP::prices::addItemSpawn;
	}
	
	return %price;
}

function CityRP_AddDemerits(%blid, %demerits)
{
	if(!$CityRP::temp::riot)
	{
		%demerits = mFloor(%demerits);
		%currentDemerits = CityRPData.getData(%blid).valueDemerits;
		
		CityRPData.getData(%blid).valueDemerits += %demerits;
		
		if(CityRPData.getData(%blid).valueDemerits >= $CityRP::pref::demerits::demoteLevel && $CityRP::jobs::law[CityRPData.getData(%blid).valueJobID] == true)
		{		
			CityRPData.getData(%blid).valueJobID = 1;
			CityRPData.getData(%blid).valueJailData = 1 SPC 0;
			
			%client = findClientByBL_ID(%blid);
			
			if(isObject(%client))
			{
				messageClient(%client, '', "\c6You have been demoted to" SPC CityRP_DetectVowel($CityRP::jobs::name[1]) SPC "\c3" @ $CityRP::jobs::name[1] @ "\c6.");
				
				%client.setInfo();
				
				if(isObject(%client.player))
				{
					serverCmdunUseTool(%client);
					
					%client.player.giveDefaultEquipment();
				}
			}
		}
	}
}

function CityRP_DetectVowel(%word)
{
	%letter = strLwr(getSubStr(%word, 0, 1));
	
	if(%letter $= "a" || %letter $= "e" || %letter $= "i" || %letter $= "o" || %letter $= "u")
	{
		return "an";
	}
	
	return "a";	
}

function CityRP_FindSpawn(%search, %id)
{
	for(%a = 0; %a < getWordCount($CityRP::temp::spawnPoints); %a++)
	{
		%brick = getWord($CityRP::temp::spawnPoints, %a);
		
		if(!isObject(%brick))
		{
			if(getWord($CityRP::temp::spawnPoints, 0) == %brick)
			{
				$CityRP::temp::spawnPoints = strReplace($CityRP::temp::spawnPoints, %brick @ ((getWordCount($CityRP::temp::spawnPoints) == 1) ? "" : " "), "");
			}
			else
			{
				$CityRP::temp::spawnPoints = strReplace($CityRP::temp::spawnPoints, " " @ %brick, "");
			}
			
			return;
		}
		
		if(strLwr(%brick.getDatablock().spawnData) !$= strLwr(%search @ (%id ? " " @ %id : "")) && %search !$= strLwr("personalSpawn"))
		{
			continue;
		}
		
		if(%search $= strLwr("personalSpawn") && (strLwr(%brick.getDatablock().spawnData) !$= strLwr("personalSpawn") || getBrickGroupFromObject(%brick).bl_id != %id))
		{
			continue;
		}
		
		%possibleSpawns = (%possibleSpawns $= "") ? %brick : %possibleSpawns SPC %brick;
	}
	
	if(%possibleSpawns !$= "")
	{
		%spawnBrick = getWord(%possibleSpawns, getRandom(0, getWordCount(%possibleSpawns) - 1));
		
		return vectorSub(%spawnBrick.getWorldBoxCenter(), "0 0" SPC (%spawnBrick.getDatablock().brickSizeZ - 3) * 0.1) SPC getWords(%spawnBrick.getTransform(), 3, 6);
	}
	
	return false;	
}

function CityRP_BuyItem(%blid, %image)
{	
	%price = CityRP_ItemPrice(%image);
	
	if(%price)
	{
		CityRPData.getData(%blid).valueDebt += %price;
		
		if(%client = findClientByBL_ID(%blid))
		{		
			messageClient(%client, '', "\c6You have charged \c3$" @ %price @ "\c6 to buy an item.");
			
			%client.SetInfo();
		}
		
		return 1;
	}
	else if(findClientByBL_ID(%blid).isAdmin)
	{
		return 1;	
	}
	
	return 0;
}

function CityRP_DoRaycast(%proj, %obj, %col)
{
	if(%proj.canOpenDoors)
	{
		if((%col.getType() & $typeMasks::fxBrickObjectType))
		{
			if(isObject(%col.door))
			{
				if(%proj.openCondition $= "legal")
				{
					for(%i = 0; %col.eventInput[%i] !$= "" && !%doorPath; %i++)
					{
						if(%col.eventOutput[%i] $= "doorOpen")
						{
							%doorPath = %col.eventOutputParameter[%i, 2];
						}
					}
					
					if(%doorPath == 0)
					{
						%doorResult = %col.doorOpenCW();
					}
					else if(%doorPath == 1)
					{
						%doorResult = %col.doorOpenCCW();
					}
					else
					{
						%doorResult = %col.doorOpen();
					}
					
					%col.schedule(3000, "doorClose");
					
					if(%doorResult == 1)
					{
						%col.schedule(3000, "doorClose");
					}
					else
					{
						commandToClient(%obj.client, 'centerPrint', "\c6The door is lodged shut!", 3);
					}
				}
				else if(%proj.openCondition $= "illegal")
				{
					if(getRandom(0, 3) > 2)
					{
						for(%i = 0; %col.eventInput[%i] !$= "" && !%doorPath; %i++)
						{
							if(%col.eventOutput[%i] $= "doorOpen")
							{
								%doorPath = %col.eventOutputParameter[%i, 2];
							}
						}
						
						if(%doorPath == 0)
						{
							%doorResult = %col.doorOpenCW();
						}
						else if(%doorPath == 1)
						{
							%doorResult = %col.doorOpenCCW();
						}
						else
						{
							%doorResult = %col.doorOpen();
						}
						
						%col.schedule(3000, "doorClose");
						
						if(%doorResult == 1)
						{
							%col.schedule(3000, "doorClose");
							
							commandToClient(%obj.client, 'centerPrint', "\c6You have commited a crime. [\c3Breaking and Entering\c6]", 3);
							%obj.client.CityRP(2, $CityRP::demerits::breakingAndEntering);
						}
						else
						{
							commandToClient(%obj.client, 'centerPrint', "\c6You have commited a crime. [\c3Attempted Breaking and Entering\c6]", 3);
							%obj.client.CityRP(2, $CityRP::demerits::attemptedBnE);
						}
					}
					else
					{
						commandToClient(%obj.client, 'centerPrint', "\c6Picklocking attempt failed", 1);	
					}	
				}
			}
			
			return;
		}
	}
	
	if(%proj.canArrest)
	{
		if((%col.getType() & $typeMasks::playerObjectType) && isObject(%col.client))
		{
			if(CityRPData.getData(%col.client.bl_id).valueDemerits < $CityRP::pref::demerits::wantedLevel && !getWord(CityRPData.getData(%col.client.bl_id).valueJailData, 1) && !CityRPData.getData(%col.client.bl_id).valueDrugs)
			{
				commandToClient(%obj.client, 'centerPrint', "\c6You have commited a crime. [\c3Hitting Innocents\c6]", 1);
				
				%obj.client.CityRP(2, $CityRP::demerits::hittingInnocents);
				
				return;
			}
			else if(CityRPData.getData(%col.client.bl_id).valueDemerits >= $CityRP::pref::demerits::wantedLevel || CityRPData.getData(%col.client.bl_id).valueDrugs)
			{
				if(%col.isMounted() && vectorLen(%col.getObjectMount().getVelocity()) > 10)
				{
						commandToClient(%obj.client, 'CenterPrint', "\c6That vehicle is moving too fast to arrest that passenger!", 3);
				}
				else
				{
					%col.client.CityRP(3, %obj.client);
				}
			}
			
			return;
		}
	}	
}

// ============================================================
// Section 2 : Brick CityRP Functions
// ============================================================
function fxDtsBrick::CityRP(%brick, %mode, %data)
{
	if(%mode == 1 && !isObject(%brick.trigger))
	{
		%datablock = %brick.getDatablock();
		
		%scale = getWord(%datablock.triggerSize, 0) / 2 SPC getWord(%datablock.triggerSize, 1) / 2 SPC getWord(%datablock.triggerSize, 2) / 2;
		
		if(mFloor(getWord(%brick.rotation, 3)) == 90)
		{
			%scale = getWord(%datablock.triggerSize, 1) / 2 SPC getWord(%datablock.triggerSize, 0) / 2 SPC getWord(%datablock.triggerSize, 2) / 2;
		}
		
		%brick.trigger = new trigger()
		{
			datablock = %datablock.triggerDatablock;
			
			position = getWords(%brick.getWorldBoxCenter(), 0, 1) SPC getWord(%brick.getWorldBoxCenter(), 2) + ((getWord(%datablock.triggerSize, 2) / 4) + (%datablock.brickSizeZ * 0.1));
			rotation = "1 0 0 0";
			scale = %scale;
			
			polyhedron = "-0.5000000 -0.5000000 -0.5000000 1.0000000 0.0000000 0.0000000 0.0000000 1.0000000 0.0000000 0.0000000 0.0000000 1.0000000";
			
			parent = %brick;
		};
		
		%boxSize = getWord(%scale, 0) / 2.5 SPC getWord(%scale, 1) / 2.5 SPC getWord(%scale, 2) / 2.5;
		
		initContainerBoxSearch(%brick.trigger.getWorldBoxCenter(), %boxSize, $typeMasks::playerObjectType);
		
		while(isObject(%player = containerSearchNext()))
		{
			%brick.trigger.getDatablock().onEnterTrigger(%brick.trigger, %player);
		}
		
		if(%brick.getDatablock().CityRPBrickType == 1)
		{
			getBrickGroupFromObject(%brick).taxes += %brick.getDatablock().taxAmount;
			getBrickGroupFromObject(%brick).lotsOwned++;
			
			if(isObject(getBrickGroupFromObject(%brick).client))
			{
				getBrickGroupFromObject(%brick).client.SetInfo();
			}
		}
	}
	
	if(%mode == 2 && isObject(%brick.trigger))
	{
		for(%a = 0; %a < clientGroup.getCount(); %a++)
		{
			if(isObject(clientGroup.getObject(%a).player) && clientGroup.getObject(%a).CityRPTrigger == %brick.trigger)
			{
				%brick.trigger.getDatablock().onLeaveTrigger(%brick.trigger, clientGroup.getObject(%a).player, true);
			}
		}
		
		%boxSize = getWord(%brick.trigger.scale, 0) / 2.5 SPC getWord(%brick.trigger.scale, 1) / 2.5 SPC getWord(%brick.trigger.scale, 2) / 2.5;
		
		initContainerBoxSearch(%brick.trigger.getWorldBoxCenter(), %boxSize, $typeMasks::playerObjectType);
		
		while(isObject(%player = containerSearchNext()))
		{
			%brick.trigger.getDatablock().onLeaveTrigger(%brick.trigger, %player);
		}
		
		%brick.trigger.delete();
		
		if(%brick.getDatablock().CityRPBrickType == 1)
		{
			getBrickGroupFromObject(%brick).taxes -= %brick.getDatablock().taxAmount;
			getBrickGroupFromObject(%brick).lotsOwned--;
			
			if(isObject(getBrickGroupFromObject(%brick).client))
			{
				getBrickGroupFromObject(%brick).client.SetInfo();
			}
			
			if(%brick.getName() !$= "")
				{
					%data = CityRPData.getData(getBrickGroupFromObject(%brick).bl_id).valueLotData;
					
					%newData = getWord(%data, 0) - 1;
					
					for(%a = 1; %a < getWordCount(%data); %a++)
					{
						if(%cancelNext)
						{
							%cancelNext = false;
							
							continue;
						}
						
						%newData = %newData SPC getWord(%data, %a);
						
						if(%a % 2 == 0)
						{
							continue;
						}
						
						%newBrick = "_" @ getWord(%data, %a);
						
						if(isObject(%newBrick) && %newBrick $= %brick.getName())
						{
							%found = true;
							
							%newData = getWords(%newData, 0, getWordCount(%newData) - 2);
							
							%cancelNext = true;
						}
					}
					
					if(%found)
					{
						CityRPData.getData(getBrickGroupFromObject(%brick).bl_id).valueLotData = %newData;
					}
				}
		}
	}
}

function fxDTSBrick::transferLot(%brick, %targetBG)
{
	%ownerBG = getBrickGroupFromObject(%brick);
	
	if(%brick.tran || !isObject(%brick))
	{
		return;
	}
	
	if(isObject(%ownerBG)) { %ownerBG.remove(%brick); }
	%targetBG.add(%brick);
	%brick.tran = 1;
	%brick.transferLot(%targetBG);
	
	for(%i = 0; %i < %brick.getNumUpBricks(); %i++)
	{
		%target = %brick.getUpBrick(%i);
		if(isObject(%target))
		{
			%target.transferLot(%targetBG);
		}
	}

	for(%i = 0; %i < %brick.getNumUpBricks(); %i++)
	{
		%target = %brick.getDownBrick(%i);
		if(isObject(%target))
		{
			%target.transferLot(%targetBG);
		}
	}
}

function fxDTSBrick::onEnterLot(%brick, %obj)
{
	$inputTarget_self = %brick;
	
	$inputTarget_client = %obj.client;
	$inputTarget_player = %obj.client.player;
	
	$inputTarget_miniGame = (isObject(getMiniGameFromObject(%obj.client))) ? getMiniGameFromObject(%obj.client) : 0;
	
	%brick.processInputEvent("OnEnterLot", %obj.client);
}

function fxDTSBrick::onLeaveLot(%brick, %obj)
{
	$inputTarget_self = %brick;
	
	$inputTarget_client = %obj.client;
	$inputTarget_player = %obj.client.player;
	
	$inputTarget_miniGame = (isObject(getMiniGameFromObject(%obj.client))) ? getMiniGameFromObject(%obj.client) : 0;
	
	%brick.processInputEvent("OnLeaveLot", %obj.client);
}

function fxDTSBrick::onTick(%brick)
{
	$inputTarget_self = %brick;
	%this.processInputEvent("onTick");
}

function fxDTSBrick::onTransferSuccess(%brick, %client)
{
	$inputTarget_self	= %brick;
	$inputTarget_player	= %client.player;
	$inputTarget_client	= %client;
	
	%brick.processInputEvent("onTransferSuccess", %client);
}

function fxDTSBrick::onTransferDecline(%brick, %client)
{
	$inputTarget_self	= %brick;
	$inputTarget_player	= %client.player;
	$inputTarget_client	= %client;
	
	%brick.processInputEvent("onTransferDecline", %client);
}

function fxDTSBrick::onVehicleDestroyed(%brick)
{
	$inputTarget_self	= %brick;
	
	%brick.processInputEvent("onVehicleDestroyed");
}

// ============================================================
// Section 3 : Client CityRP Functions
// ============================================================
function gameConnection::CityRP(%this, %mode, %data)
{
	if(%mode == 1)
	{
		%this.SetInfo();
	}
	
	if(%mode == 2)
	{
		CityRP_AddDemerits(%this.bl_id, %data);
	}
	
	if(%mode == 3)
	{		
		%ticks = (mFloor(CityRPData.getData(%this.bl_id).valueDemerits / ($CityRP::tick::speed * 50)) > 0) ? mFloor(CityRPData.getData(%this.bl_id).valueDemerits / ($CityRP::tick::speed * 50)) : 1;
		%ticks += mFloor(CityRPData.getData(%this.bl_id).valueDrugs * $CitRP::pref::demsPerDrugUnit * (%this.sellingDrugs ? 2 : 1));
		
		if(%ticks > 6)
		{
			%ticks = 6;
		}
		else if(%ticks <= 0)
		{
			return;
		}
		
		if(getWord(CityRPData.getData(%this.bl_id).valueJailData, 1) < 1)
		{
			if(%this.player.currTool)
			{
				serverCmddropTool(%this, %this.player.currTool);
			}
		}
		
		%ticks += getWord(CityRPData.getData(%this.bl_id).valueJailData, 1);
		
		CityRPData.getData(%data.bl_id).valueMoney += mFloor($CityRP::prices::jailingBonus * %ticks);
		
		messageAll('', "\c3" @ %data.name SPC "\c6has jailed \c3" @ %this.name SPC "\c6for \c3" @ %ticks SPC"\c6tick" @ ((%ticks == 1) ? "" : "s") @ ".", 5);
		commandToClient(%this, 'centerPrint', "\c3" @ %data.name SPC "\c6has jailed you for \c3" @ %ticks SPC"\c6tick" @ ((%ticks == 1) ? "" : "s") @ ".", 5);
		commandToClient(%data, 'centerPrint', "\c6You have jailed \c3" @ %this.name SPC "\c6for \c3" @ %ticks SPC"\c6tick" @ ((%ticks == 1) ? "" : "s") @ ". You now have" SPC %data.CityRp(5) @ "\c6.", 5);
		
		CityRPData.getData(%this.bl_id).valueJailData = 1 SPC %ticks;
		CityRPData.getData(%this.bl_id).valueDemerits = 0;
		CityRPData.getData(%this.bl_id).valueDrugs = 0;
		
		%data.SetInfo();
		
		if($CityRP::jobs::law[CityRPData.getData(%this.bl_id).valueJobID])
		{
			messageClient(%this, '', "\c6You have been demoted to" SPC CityRP_DetectVowel($CityRP::jobs::name[1]) SPC "\c3" @ $CityRP::jobs::name[1] SPC "\c6since you were jailed.");
			
			CityRPData.getData(%this.bl_id).valueJobID = 1;
		}
		
		if(CityRPData.getData(%this.bl_id).valueBounty > 0)
		{
			messageClient(%data, '', "\c6Wanted man was apprehended successfully. His bounty money has been wired to your bank account.");
			CityRPData.getData(%data.bl_id).valueBank += CityRPData.getData(%this.bl_id).valueBounty;
			CityRPData.getData(%this.bl_id).valueBounty = 0;
		}
		
		if(isObject(%this.player.tempBrick))
		{
			%this.player.tempBrick.delete();
		}
		
		%this.player.delete();
		%this.spawnPlayer();
	}
	
	if(%mode == 4)
	{
		%this.buyResources();
	}
	
	if(%mode == 5)
	{
		// Determines user's active cash.
		if(CityRPData.getData(%this.bl_id).valueMoney >= 0)
		{
			%money = "\c3$" @ CityRPData.getData(%this.bl_id).valueMoney;
		}
		else
		{
			%money = "\c0($" @ strreplace(CityRPData.getData(%this.bl_id).valueMoney, "-", "")  @ ")";
		}
		return %money;
	}
}

function gameConnection::BuyItem(%client, %image)
{	
	%price = CityRP_ItemPrice(%image);
	
	if(!%price)
	{
		return 0;
	}
	else if((CityRPData.getData(%client.bl_id).valueMoney - %price) < 0)
	{
		messageClient(%client, '', "\c6You can't afford to spawn this item. (\c3$" @ CityRPData.getData(%client.bl_id).valueMoney @ "\c6/\c0$" @ %price @ "\c6)");
		
		return 0;
	}
	
	messageClient(%client, '', "\c6You have paid \c3$" @ %price @ "\c6 to spawn this item.");
	
	CityRPData.getData(%client.bl_id).valueMoney -= %price;
	
	%client.SetInfo();
	
	return 1;
}

function gameConnection::setInfo(%client)
{
	if(%client.guise)
	{
		if(isObject(%client.guise))
		{
			%target = findClientByBL_ID(%client.guise.bl_id);
		}
		else
		{
			%client.guise = NULL;
		}
	}
	
	if(isObject(%client.player))
	{
		if(%target)
		{
			%client.player.setShapeName("[" @ (getWord(CityRPData.getData(%target.bl_id).valueJailData, 1) ? "Convict" : ($CityRP::jobs::hideJobName[CityRPData.getData(%target.bl_id).valueJobID] ? $CityRP::jobs::name[1] : $CityRP::jobs::name[CityRPData.getData(%target.bl_id).valueJobID])) @ "]" SPC %target.name);
		}
		else
		{
			%client.player.setShapeName("[" @ (getWord(CityRPData.getData(%client.bl_id).valueJailData, 1) ? "Convict" : ($CityRP::jobs::hideJobName[CityRPData.getData(%client.bl_id).valueJobID] ? $CityRP::jobs::name[1] : $CityRP::jobs::name[CityRPData.getData(%client.bl_id).valueJobID])) @ "]" SPC %client.name);
		}
	}
	
	CityRPData.getData(%client.bl_id).valueMoney = mFloor(CityRPData.getData(%client.bl_id).valueMoney);
	
	// Begin String Concat
	
	// Job
	%client.cityRPPrint = "\c6Job: \c3" @ (getWord(CityRPData.getData(%client.bl_id).valueJailData, 1) ? "Convict" : $CityRP::jobs::name[CityRPData.getData(%client.bl_id).valueJobID]);
	
	// Money
	%client.cityRPPrint = %client.cityRPPrint SPC "\c6Money:" SPC %client.CityRP(5);
	
	// Income
	if($CityRP::jobs::pay[CityRPData.getData(%client.bl_id).valueJobID] > 0)
	{
		%client.cityRPPrint = %client.cityRPPrint SPC "\c6Income: \c3$" @ $CityRP::jobs::pay[CityRPData.getData(%client.bl_id).valueJobID];
	}
	
	// Taxes
	if(%client.brickGroup.taxes > 0)
	{
		%client.cityRPPrint = %client.cityRPPrint SPC "\c6Taxes: \c3$" @ %client.brickGroup.taxes;
	}
	
	// Resources
	if(getWord(CityRPData.getData(%client.bl_id).valueJailData, 1) || $CityRP::jobs::labor[CityRPData.getData(%client.bl_id).valueJobID])
	{
		%client.cityRPPrint = %client.cityRPPrint SPC "\c6Lumber: \c3" @ (strlen(getWord(CityRPData.getData(%client.bl_id).valueResources, 0)) > 0 ? getWord(CityRPData.getData(%client.bl_id).valueResources, 0) : 0) SPC "\c6Ore: \c3" @ (strlen(getWord(CityRPData.getData(%client.bl_id).valueResources, 1)) > 0 ? getWord(CityRPData.getData(%client.bl_id).valueResources, 1) : 0);
	}
	
	// Lot
	if(isObject(%client.CityRPLotBrick))
	{
		%client.cityRPPrint = %client.cityRPPrint SPC "<just:right><font:palatino linotype:16><color:ffffff>Owner: <color:fff000>" @ getBrickGroupFromObject(%client.CityRPLotBrick).name;	
	}
	
	// End String Concat
	
	commandToClient(%client, 'bottomPrint', %client.cityRPPrint);
}

function GameConnection::requestFunds(%client, %serviceName, %fund)
{
	if(isObject(%client.player) && !%client.player.CityRP_lastProcessBrick  && isObject($lastProcessedBrick_cityRP))
	{
		//You might want to check if they're already in an accept/decline thing, or the distance to $lastProcessedBrick_cityRP, etc.
		
		%client.player.CityRP_lastProcessBrick = $lastProcessedBrick_cityRP;
		%client.player.serviceFee = %fund;
		
		messageClient(%client,'',"\c6Service \"\c3" @ %serviceName @ "\c6\" requests \c3$" @ %fund SPC "\c6.");
		messageClient(%client,'',"\c6Accept with \c3^yes\c6, decline with \c3^no\c6.");
		
		//other stuff
	}
	else if(%client.player.CityRP_lastProcessBrick)
	{
		if(%client.player.CityRP_lastProcessBrick != $lastProcessedBrick_cityRP)
		{
			messageClient(%client, '', "\c6You already have a charge request from another service! Type \c3^no to reject it.");
		}
	}
}

function gameConnection::buyResources(%client)
{
	%totalResources = getWord(CityRPData.getData(%client.bl_id).valueResources, 0) + getWord(CityRPData.getData(%client.bl_id).valueResources, 1);
	
	if(mFloor(%totalResources * $CityRP::prices::resourcePrice) > 0)
	{				
		%product = mFloor(%totalResources * $CityRP::prices::resourcePrice);
		
		if($CityRP::jobs::labor[CityRPData.getData(%client.bl_id).valueJobID] && !getWord(CityRPData.getData(%client.bl_id).valueJobID, 1))
		{
			%product *= getRandom(1.5, 2.0);
			%product = mFloor(%product);
		}
		
		CityRPData.getData(%client.bl_id).valueMoney += %product;
		messageClient(%client, '', "\c6The state has bought all of your resources for \c3$" @ %product @ "\c6.");
	}
	
	CityRPData.getData(%client.bl_id).valueResources = "0 0";
	
	%client.SetInfo();	
}

function player::giveDefaultEquipment(%this)
{
	if(getWord(CityRPData.getData(%this.client.bl_id).valueJailData, 1) < 1)
	{
		if(CityRPData.getData(%this.client.bl_id).valueTools $= "")
		{
			%tools = ($CityRP::pref::giveDefaultTools ? $CityRP::pref::defaultTools @ " " : "") @ $CityRP::jobs::tools[CityRPData.getData(%this.client.bl_id).valueJobID]; 
		}
		else
		{
			%tools = CityRPData.getData(%this.client.bl_id).valueTools;
		}
		
		for(%a = 0; %a < %this.getDatablock().maxTools; %a++)
		{
			if(%a > getWordCount(%tools) - 1)
			{
				%this.tool[%a] = "";
				messageClient(%this.client, 'MsgItemPickup', "", %a, 0);
				
				continue;
			}
			
			%this.tool[%a] = nameToID(getWord(%tools, %a));
			
			messageClient(%this.client, 'MsgItemPickup', "", %a, nameToID(getWord(%tools, %a)));
		}
		
		%this.maxWeapons = %this.getDatablock().maxTools;
	}
	else
	{
		for(%a = 0; %a < %this.getDatablock().maxTools; %a++)
		{
			switch(%a)
			{
				case 0:
					%tool = "CityRPLumberjackItem";
				case 1:
					%tool = "CityRPShovelItem";
				default:
					%tool = "";
			}
			%this.tool[%a] = nameToID(%tool);
			
			messageClient(%this.client, 'MsgItemPickup', "", %a, nameToID(%tool));
		}
	}
}

// ============================================================
// Section 4 : Trigger Bullshit
// ============================================================
function CityRPLotTriggerData::onEnterTrigger(%this, %trigger, %obj)
{
	parent::onEnterTrigger(%this, %trigger, %obj);
	
	%trigger.parent.onEnterLot(%obj);
	
	if(!isObject(%obj.client))
	{
		return;
	}
	
	%obj.client.CityRPTrigger = %trigger;
	%obj.client.CityRpLotBrick = %trigger.parent;
	
	%obj.client.SetInfo();
}

function CityRPLotTriggerData::onLeaveTrigger(%this, %trigger, %obj)
{
	%trigger.parent.onLeaveLot(%obj);
	
	if(!isObject(%obj.client) || %obj.client.CityRPTrigger != %trigger)
	{
		return;
	}
	
	%obj.client.CityRPTrigger = "";
	%obj.client.CityRpLotBrick = "";
	
	%obj.client.SetInfo();
}

function CityRPInputTriggerData::onEnterTrigger(%this, %trigger, %obj)
{
	if(!isObject(%obj.client))
	{
		return;
	}
	
	%obj.client.CityRPTrigger = %trigger;
	
	%trigger.parent.getDatablock().parseData(%trigger.parent, %obj.client, true, "");
}

function CityRPInputTriggerData::onLeaveTrigger(%this, %trigger, %obj, %a)
{
	if(!isObject(%obj.client))
	{
		return;
	}
	
	if(%obj.client.CityRPTrigger == %trigger)
	{
		%trigger.parent.getDatablock().parseData(%trigger.parent, %obj.client, false, "");
		
		%obj.client.CityRPTrigger = "";
	}
}

// ============================================================
// Section 5 : CrpCmds
// ============================================================
function CrpCmdgiveMoney(%client, %args)
{
	%money = mFloor(getWord(%args, 0));
	
	if(%money < 1)
	{
		messageClient(%client, '', "\c6You must enter a valid amount of money to give.");
		
		return 1;
	}
	
	if(CityRPData.getData(%client.bl_id).valueMoney - %money < 0)
	{
		messageClient(%client, '', "\c6You don't have that much money to give.");
		
		return 1;
	}
	
	if(!isObject(%client.player))
	{
		messageClient(%client, '', "\c6Spawn first before you use this command.");
		
		return 1;
	}
	
	if(isObject(%client.player))
	{
		%target = containerRayCast(%client.player.getEyePoint(), vectorAdd(vectorScale(vectorNormalize(%client.player.getEyeVector()), 5), %client.player.getEyePoint()), $typeMasks::playerObjectType).client;
	}
	
	if(!isObject(%target))
	{
		messageClient(%client, '', "\c6You must be looking at and be in a reasonable distance of the player in order to give them money.");
	
		return 1;
	}
	
	messageClient(%client, '', "\c6You give \c3$" @ %money SPC "\c6to \c3" @ %target.name @ "\c6.");
	messageClient(%target, '', "\c3" @ %client.name SPC "\c6has given you \c3$" @ %money @ "\c6.");
	
	CityRPData.getData(%client.bl_id).valueMoney -= %money;
	CityRPData.getData(%target.bl_id).valueMoney += %money;
	
	%client.SetInfo();
	%target.SetInfo();
	return 1;
}

function CrpCmdgrantMoney(%client, %args)
{
	if(!%client.isAdmin)
	{
		messageClient(%client, '', "\c6You must be admin to use the this command.");
		
		return 1;
	}
	
	%money = mFloor(getWord(%args, 0));
	
	if(%money < 1)
	{
		messageClient(%client, '', "\c6You must enter a valid amount of money to grant.");
		
		return 1;
	}
	
	if(!isObject(%client.player) && !isObject(findClientByName(getWords(%args, 1, getWordCount(%args) - 1))))
		{
		messageClient(%client, '', "\c6Spawn first before you use this command or enter a valid player's name.");
		
		return 1;
	}
	
	if(getWords(%args, 1, getWordCount(%args) - 1) !$= "")
	{
		%target = findClientByName(getWords(%args, 1, getWordCount(%args) - 1));
	}
		
	if(!isObject(%target))
	{
		%target = containerRayCast(%client.player.getEyePoint(), vectorAdd(vectorScale(vectorNormalize(%client.player.getEyeVector()), 5), %client.player.getEyePoint()), $typeMasks::playerObjectType).client;
	}
	
	if(!isObject(%target))
	{
		messageClient(%client, '', "\c6You must be looking at or enter the name of the player in order to grant to them.");
		
		return 1;
	}
	
	messageClient(%client, '', "\c6You grant \c3$" @ %money SPC "\c6to \c3" @ %target.name @ "\c6.");
	messageClient(%target, '', "\c3" @ %client.name @ "\c6 has granted you \c3$" @ %money @ "\c6.");
	
	CityRPData.getData(%target.bl_id).valueMoney += %money;
	
	%target.SetInfo();
	
	return 1;
}

function CrpCmddeductMoney(%client, %args)
{
	if(!%client.isAdmin)
	{
		messageClient(%client, '', "\c6You must be admin to use the this command.");
		
		return 1;
	}
	
	%money = mFloor(getWord(%args, 0));
	
	if(%money < 1)
	{
		messageClient(%client, '', "\c6You must enter a valid amount of money to deduct.");
		
		return 1;
	}
	
	if(!isObject(%client.player) && !isObject(findClientByName(getWords(%args, 1, getWordCount(%args) - 1))))
	{
		messageClient(%client, '', "\c6Spawn first before you use this command or enter a valid player's name.");
	
		return 1;
	}
	
	if(getWords(%args, 1, getWordCount(%args) - 1) !$= "")
	{
		%target = findClientByName(getWords(%args, 1, getWordCount(%args) - 1));
	}

	if(!isObject(%target))
	{
		%target = containerRayCast(%client.player.getEyePoint(), vectorAdd(vectorScale(vectorNormalize(%client.player.getEyeVector()), 5), %client.player.getEyePoint()), $typeMasks::playerObjectType).client;
	}
	
	if(!isObject(%target))
	{
		messageClient(%client, '', "\c6You must be looking at or enter the name of the player in order to deduct money from them.");
		
		return 1;
	}
	
	messageClient(%client, '', "\c6You deduct \c3$" @ %money SPC "\c6from \c3" @ %target.name @ "\c6.");
	messageClient(%target, '', "\c3" @ %client.name @ "\c6 has deducted \c3$" @ %money @ "\c6 from you.");
	
	CityRPData.getData(%target.bl_id).valueMoney -= %money;
	
	%target.SetInfo();
	
	return 1;

}

function CrpCmdjobs(%client, %args)
{
	return CrpCmdjob(%client, %args);
}

function CrpCmdjob(%client, %args)
{
	if(strLwr(getWords(%args, 0, getWordCount(%args) - 1)) $= "")
	{
		messageClient(%client, '', "\c6Type \c3^help jobs\c6 to see a list of jobs.");
		
		return 1;
	}
	
	for(%a = 1; %a <= $CityRP::jobs; %a++)
	{
		if(strLwr(getWords(%args, 0, getWordCount(%args) - 1)) $= strLwr($CityRP::jobs::name[%a]))
		{
			if(%a == CityRPData.getData(%client.bl_id).valueJobID)
			{
				messageClient(%client, '', "\c6You are already" SPC CityRP_DetectVowel($CityRP::jobs::name[%a]) SPC "\c3" @ $CityRP::jobs::name[%a] @ "\c6!");
				
				return 1;
			}
			
			if($CityRP::jobs::law[%a] && getWord(CityRPData.getData(%client.bl_id).valueJailData, 0) == 1)
			{
				messageClient(%client, '', "\c6You don't have a clean criminal record. You can't become" SPC CityRP_DetectVowel($CityRP::jobs::name[%a]) SPC "\c3" @ $CityRP::jobs::name[%a] @ "\c6.");
				
				return 1;
			}
			
			if(mFloor($CityRP::jobs::initialInvestment[%a]) > 0)
			{
				if(CityRPData.getData(%client.bl_id).valueMoney < mFloor($CityRP::jobs::initialInvestment[%a]))
				{
					messageClient(%client, '', "\c6You need at least \c3$" @ mFloor($CityRP::jobs::initialInvestment[%a]) SPC "\c6in order to apply for this job.");
					
					return 1;
				}
				
				messageClient(%client, '', "\c6You have paid \c3$" @ mFloor($CityRP::jobs::initialInvestment[%a]) @ "\c6 to become" SPC CityRP_DetectVowel($CityRP::jobs::name[%a]) SPC "\c3" @ $CityRP::jobs::name[%a] @ "\c6.");
			}
			else
			{
				messageClient(%client, '', "\c6You are now" SPC CityRP_DetectVowel($CityRP::jobs::name[%a]) SPC "\c3" @ $CityRP::jobs::name[%a] @ "\c6.");
			}
			
			if($CityRP::jobs::tools[CityRPData.getData(%client.bl_id).valueJobID])
			{
				%brickGroup = "brickGroup_" @ %client.bl_id;
				
				%display = false;
				
				for(%b = 0; %b < %brickGroup.getCount(); %b++)
				{
					%brickGroup.getObject(%b).setItem(0, (isObject(%brickGroup.client) ? %brickGroup.client : 0), true);
					
					%display = true;
				}
				
				if(%display)
				{
					messageClient(%client, '', "\c6Since you are no longer" SPC CityRP_DetectVowel($CityRP::jobs::name[CityRPData.getData(%client.bl_id).valueJobID]) SPC "\c3" @$CityRP::jobs::name[CityRPData.getData(%client.bl_id).valueJobID] @ "\c6, your item spawns have been removed.");
				}
			}
			
			CityRPData.getData(%client.bl_id).valueMoney -= mFloor($CityRP::jobs::initialInvestment[%a]);
			CityRPData.getData(%client.bl_id).valueJobID = %a;
			
			if(isObject(%client.player))
			{
				serverCmdunUseTool(%client);
				
				%client.player.giveDefaultEquipment();
			}
			
			%client.SetInfo();
			
			return 1;
		}
	}
	
	messageClient(%client, '', "\c6No such job as \c3" @ getWords(%args, 0, getWordCount(%args) - 1) @ "\c6. Type \c3^job\c6 to see a list of the jobs.");
	
	return 1;
}

function CrpCmdhelp(%client, %args)
{
	%section = strLwr(getWord(strLwr(%args), getWordCount(%args) - 1));
	
	if(%section $= "")
	{
		CityRPHelp.displayHelp(%client, "main");
	}
	else if(%section $= "jobs")
	{
		messageClient(%client, '', "\c6Type \c3^job\c6 then one of the jobs below to become that job.");
		
		for(%a = 1; %a <= $CityRP::jobs; %a++)
		{
			messageClient(%client, '', "\c3" @ $CityRP::jobs::name[%a] SPC "\c6- Inital Investment: \c3" @ $CityRP::jobs::initialInvestment[%a] SPC "\c6Pay: \c3" @ $CityRP::jobs::pay[%a]);
			messageClient(%client, '', $CityRP::jobs::helpline[%a]);
		}
		
		return 1;
	}
	else if(%section $= "lots")
	{
		messageClient(%client, '', "\c6This is a list of lots you can plant.");
		
		for(%a = 0; %a < datablockGroup.getCount(); %a++)
		{
			%datablock = datablockGroup.getObject(%a);
			
			if(%datablock.CityRPBrickType == 1)
			{
				messageClient(%client, '', "\c3" @ %datablock.uiName SPC "\c6- Size: \c3" @ %datablock.brickSizeX @ "x" @ %datablock.brickSizeY SPC "\c6Cost: \c3" @ %datablock.initialPrice SPC "\c6Tax: \c3" SPC %datablock.taxAmount);
			}
		}
		
		return 1;
	}
	else if(%section $= "items")
	{
		messageClient(%client, '', "\c6This is a list of item prices.");
		
		for(%a = 0; %a < datablockGroup.getCount(); %a++)
		{
			%datablock = datablockGroup.getObject(%a);
			
			if((strLwr(%datablock.getClassName()) !$= strLwr("itemData") && strLwr(%datablock.getClassName()) !$= "weapon") || %datablock.uiName $= "")
			{
				continue;
			}
			
			if(%datablock.noSpawn)
			{
				continue;
			}
			
			%price = (isObject(%datablock.image) && isObject(%datablock.image.projectile)) ? mFloor(%datablock.image.projectile.directDamage) : 0;
			
			if(%price == 0 || %price == false)
			{
				continue;
			}
			
			messageClient(%client, '', "\c3" @ %datablock.uiName SPC "\c6- Price: \c3$" @ CityRP_ItemPrice(%datablock.image));
		}
		
		return 1;
	}
	else
	{
		messageClient(%client, '', "\c6Attempted to load help doc \c6[\c3" @ %section @ "\c6]...");
		if(!CityRPHelp.displayHelp(%client, %section))
		{
			messageClient(%client, '', "\c6Help doc \c0does not exist\c6!");
		}
		return 1;
	}
}

function CrpCmdreset(%client, %args)
{
	if(CityRPData.getData(%client.bl_id).valueMoney - $CityRP::prices::reset < 0)
	{
		messageClient(%client, '', "\c6You need at least \c3$" @ $CityRP::prices::reset SPC "\c6to do that.");
		
		return 1;
	}
	
	messageClient(%client, '', "\c6Your account has been reset.");
	
	CityRPData.removeData(%client.bl_id);
	CityRPData.addData(%client.bl_id);
	
	if(isObject(%client.player))
	{
		%client.player.delete();
		%client.spawnPlayer();
	}
	
	return 1;
}

function CrpCmdpassTime(%client, %args)
{
	if(!%client.isAdmin)
	{
		messageClient(%client, '', "\c6You must be admin to use the this command.");
			
			return 1;
	}
	
	CityRP_Tick();
	
	messageAll('', "\c3" @ %client.name SPC "\c6has forced \c31\c6 tick to pass.");
	
	return 1;
}

function CrpCmdresetUser(%client, %args)
{
	if(%client.isAdmin)
	{
		if(getWords(%args, 0, getWordCount(%args) - 1) !$= "")
		{
			%target = findClientByName(getWords(%args, 0, getWordCount(%args) - 1));
		}
		else
		{
			messageClient(%client, '' , "\c6Please enter a name.");	
			return 1;
		}
		
		if(!isObject(%target))
		{
			messageClient(%client, '', "\c6That person does not exist.");
			return 1;
		}
			
		
		messageClient(%target, '', "\c6Your account was reset by an admin.");
		messageClient(%client, '', "\c3" @ %target.name @ "\c6's account was reset.");
		
		CityRPData.removeData(%target.bl_id);
		CityRPData.addData(%target.bl_id);
		
		if(isObject(%target.player))
		{
			%target.player.delete();
			%target.spawnPlayer();
		}
	}
	
	return 1;	
}

function CrpCmdpardon(%client, %args)
{
	if($CityRP::jobs::canPardon[CityRPData.getData(%client.bl_id).valueJobID] || %client.isAdmin)
	{		
		if(getWords(%args, 0, getWordCount(%args) - 1) !$= "")
		{
			%target = findClientByName(getWords(%args, 0, getWordCount(%args) - 1));
		}
		else
		{
			messageClient(%client, '' , "\c6Please enter a name.");	
			return 1;
		}
		
		if(!isObject(%target))
		{
			messageClient(%client, '', "\c6That person does not exist.");
			return 1;
		}
		
		if(getWord(CityRPData.getData(%target.bl_id).valueJailData, 1) $= 0)
		{
			messageClient(%client, '', "\c6That person is not a convict.");
			return 1;
		}
		
		if(CityRPData.getData(%client.bl_id).valueMoney < ($CityRP::pref::demerits::pardonCost * getWord(CityRPData.getData(%target.bl_id).valueJailData, 1)) && !%client.isAdmin)
		{
			messageClient(%client, '', "\c6You need at least \c3$" @ $CityRP::pref::demerits::pardonCost SPC "\c6to pardon someone.");
			return 1;
		}
		
		if(%target == %client && !%client.isAdmin)
		{
			messageClient(%client, '', "\c6The length of your legal corruption only goes so far.\nYou cannot pardon yourself.");
			return 1;
		}
		
		CityRPData.getData(%client.bl_id).valueMoney -= (%client.isAdmin ? 0 : $CityRP::pref::demerits::pardonCost);
		CityRPData.getData(%target.bl_id).valueJailData = getWord(CityRPData.getData(%target.bl_id).valueJailData, 0) SPC 0;
		
		messageClient(%client, '', "\c6You have let\c3" SPC %target.name SPC "\c6out of prison.");
		messageClient(%target, '', "\c3" @ %client.name SPC "\c6has issued you a pardon.");
		
		%client.CityRP(4);
		%target.player.delete();
		%target.spawnPlayer();
		%client.SetInfo();
	}
	else
	{
		messageClient(%client, '', "\c6You can't pardon people.");
		return 1;
	}
	return 1;
}

function CrpCmdlocal(%client, %args)
{
	if(isObject(%client.player))
	{
		for(%i = 0; %i < ClientGroup.getCount(); %i++)
		{
			%subClient = ClientGroup.getObject(%i);
			if(%client != %subClient)
			{
				if(isObject(%subClient.player))
				{
					%sCpos = %subClient.player.getPosition();
					%cPos = %client.player.getPosition() ;
					
					if((getWord(%sCpos, 0) - getWord(%cPos, 0) >= -16 && getWord(%sCpos, 0) - getWord(%cPos, 0) <= 16)
						|| (getWord(%sCpos, 1) - getWord(%cPos, 1) >= -16 && getWord(%sCpos, 1) - getWord(%cPos, 1) <= 16)
						&& (getWord(%sCpos, 2) - getWord(%cPos, 2) >= -16 && getWord(%sCpos, 2) - getWord(%cPos, 2) <= 16))
					{
						messageClient(%subClient, '', "\c6(\c7Local\c6) \c3" @ %client.name @ "\c6:" SPC %args);
						%recieveCount++;
					}
				}
			}
			else
			{
				messageClient(%client, '', "\c6(\c7Local\c6) \c3" @ %client.name @ "\c6:" SPC %args);
			}
		}
		echo("(Local to" SPC %recieveCount @ ")" SPC %client.name @ ":" SPC %args);
		messageClient(%client, '', "\c3" @ (%recieveCount > 0 ? %recieveCount SPC "\c6" @ (%recieveCount > 1 ? "people" : "person") : "No one\c6") SPC "recieved your local message.");
	}
	return 1;
}

function CrpCmdRainMoney(%client, %args)
{
	if(%client.isAdmin)
	{
		if(mFloor(%args))
		{
			if(mFloor(%args) > 250)
			{
				%args = 250;
			}
			else if(mFloor(%args) < 0)
			{
				return;
			}
			
			messageAll('', "\c6It's raining \c2money\c6 near \c3" @ %client.name @ "\c6!");
			for(%i = 0; %i <= %args; %i++)
			{
				%cash = new Item()
				{
					datablock = cashItem;
					value = mFloor(getRandom(1, 5));
					canPickup = false;
				};
				%randomPosition = setWord(%client.player.getTransform(), 2, getWord(%client.player.getTransform(), 2) + 100);
				%randomPosition = setWord(%randomPosition, 0, getRandom(getWord(%randomPosition, 0) - 64, getWord(%randomPosition, 0) + 64));
				%randomPosition = setWord(%randomPosition, 1, getRandom(getWord(%randomPosition, 1) - 64, getWord(%randomPosition, 1) + 64));
				
				%randomTime = getRandom(1, 30) * 1000;
				
				%cash.schedule(%randomTime,"setTransform", %randomPosition);
				MissionCleanup.schedule(%randomTime + 1, "add", %cash);
				%cash.schedule(%randomTime + 2, "setShapeName", ("$" @ %cash.value));
			}
		}
		else
		{
			messageClient(%client, '', "\c6Please enter a valid number.");
		}
	}
	else
	{
		messageClient(%client, '', "\c6You need to be an Admin to use this function.");
	}
	
	return 1;
}

function CrpCmdYes(%client)
{
	if(isObject(%this.plyaer) && isObject(%client.player.CityRP_lastProcessBrick))
	{
		if(VectorDist(%client.player.CityRP_lastProcessBrick.getPosition(), %client.player.getPosition()) < 16)
		{
			if(CityRPData.getData(%client.bl_id).valueMoney >= %client.player.serviceFee)
			{
				CityRPData.getData(%client.bl_id).valueMoney -= %client.player.serviceFee;
				CityRPData.getData(%client.player.CityRP_lastProcessBrick.getGroup().bl_id).valueBank += %client.player.serviceFee;
				
				messageClient(%client, '', "\c6You have accepted the service fee of \c3$" @ %client.player.serviceFee @ "\c6!");
				%client.setInfo();
				
				if(%client.player.CityRP_lastProcessBrick.getGroup().client)
				{
					messageClient(%client.player.CityRP_lastProcessBrick.getGroup().client, '', "\c3" @ %client.name @ "\c6 has wired you \c3$" @ %client.player.serviceFee @ "\c6 for a service.");
				}
				
				%client.player.CityRP_lastProcessBrick.onTransferSuccess(%client);
			}
			else
			{
				messageClient(%client, '', "\c6You cannot afford this service.");
			}
			%client.player.CityRP_lastProcessBrick = NULL;
			%client.player.serviceFee = 0;
		}
		else
		{
			%client.player.CityRP_lastProcessBrick = NULL;
			%client.player.serviceFee = 0;
			messageClient(%client, '', "\c6You are too far away from the service to purchase it!");
		}
	}
	else
	{
		messageClient(%client, '', "\c6You have no active tranfers that you may accept!");
	}
	return 1;
}

function CrpCmdNo(%client)
{
	if(isObject(%client.player.CityRP_lastProcessBrick))
	{
		messageClient(%client, '', "\c6You have rejected the service fee!");
		%client.player.CityRP_lastProcessBrick.onTransferDecline(%client);
		%client.player.CityRP_lastProcessBrick = NULL;
		%client.player.serviceFee = 0;
	}
	else
	{
		messageClient(%client, '', "\c6You have no active tranfers that you may decline!");
	}
	return 1;
}

function CrpCmdaddDemerits(%client, %args)
{
	if(!%client.isAdmin)
	{
		messageClient(%client, '', "\c6You must be admin to use the this command.");
		
		return 1;
	}
	
	%demerits = mFloor(getWord(%args, 0));
	
	if(%demerits < 1)
	{
		messageClient(%client, '', "\c6You must enter a valid amount of demerits to give.");
		
		return 1;
	}
	
	if(!isObject(%client.player) && !isObject(findClientByName(getWords(%args, 1, getWordCount(%args) - 1))))
		{
		messageClient(%client, '', "\c6Spawn first before you use this command or enter a valid player's name.");
		
		return 1;
	}
	
	if(getWords(%args, 1, getWordCount(%args) - 1) !$= "")
	{
		%target = findClientByName(getWords(%args, 1, getWordCount(%args) - 1));
	}
		
	if(!isObject(%target))
	{
		%target = containerRayCast(%client.player.getEyePoint(), vectorAdd(vectorScale(vectorNormalize(%client.player.getEyeVector()), 5), %client.player.getEyePoint()), $typeMasks::playerObjectType).client;
	}
	
	if(!isObject(%target))
	{
		messageClient(%client, '', "\c6You must be looking at or enter the name of the player in order to grant to them.");
		
		return 1;
	}
	
	commandToClient(%target, 'centerPrint', "\c6You have commited a crime. [\c3Angering a Badmin\c6]", 5);
	messageClient(%client, '', '\c6User \c3%1 \c6was given \c3%2\c6 demerits.', %target.name , mFloor(getWord(%args, 0)));
	CityRP_AddDemerits(%target.bl_id, mFloor(getWord(%args, 0)));
	
	return 1;	
}

function CrpCmdEraseRecord(%client, %args)
{
	if(!%client.isAdmin || $CityRP::jobs::canPardon[CityRPData.getData(%client.bl_id).valueJobID])
	{
		messageClient(%client, '', "\c6You do not have access to this command.");
		
		return 1;
	}
	
	if(!isObject(%client.player) && !isObject(findClientByName(getWords(%args, 0, getWordCount(%args) - 1))))
		{
		messageClient(%client, '', "\c6Spawn first before you use this command or enter a valid player's name.");
		
		return 1;
	}
	
	if(getWords(%args, 0, getWordCount(%args) - 1) !$= "")
	{
		%target = findClientByName(getWords(%args, 0, getWordCount(%args) - 1));
	}
		
	if(!isObject(%target))
	{
		%target = containerRayCast(%client.player.getEyePoint(), vectorAdd(vectorScale(vectorNormalize(%client.player.getEyeVector()), 5), %client.player.getEyePoint()), $typeMasks::playerObjectType).client;
	}
	
	if(!isObject(%target))
	{
		messageClient(%client, '', "\c6You must be looking at or enter the name of the player in order to grant to them.");
		
		return 1;
	}
	
	if(!%client.isAdmin && CityRPData.getData(%client.bl_id).valueMoney < $CityRP::pref::demerits::recordShredCost)
	{
		messageClient(%client, '','\c6You need at least \c3$%1\c6 to erase someone\'s record.', $CityRP::pref::demerits::recordShredCost);
		return 1;
	}
	
	if(!getWord(CityRPData.getData(%target.bl_id).valueJailData, 0))
	{
		messageClient(%client, '','\c3%1\c6 doesn\'t even have a criminal record!', %target.name);
		return 1;
	}
	
	messageClient(%target, '', '\c6Your criminal record was reset by \c3%1\c6.', %client.name);
	messageClient(%client, '','\c3%1\c6\'s criminal record was ran through a paper shredder.', %target.name);
	
	CityRPData.getData(%target.bl_id).valueJailData = "0 0";
	CityRPData.getData(%client.bl_id).valueMoney -= (!%client.isAdmin ? $CityRP::pref::demerits::recordShredCost : 0);
	
	if(isObject(%target.player))
	{
		%target.player.delete();
		%target.spawnPlayer();
	}
	
	return 1;
}

// Section 5.1 : Test Functions
function CrpCmdRebuildPrefs(%client)
{
	if(%client.isAdmin)
	{
		$CityRP::Jobs = 0;
		$CityRP::temp::rebuildPref = true;
		
		for(%i = 1; isFile("./jobs/" @ %i @ ".cs"); %i++)
		{		
			exec("./jobs/" @ %i @ ".cs");	
		}
		
		$CityRP::temp::rebuildPref = false;
		
		messageClient(%client, '', "\c2Finished.");
		return 1;
	}
}

function CrpCmdRiot(%client)
{
	return;
	if(!$CityRP::temp::riot)
	{
		if(!$CityRP::temp::riotCount)
		{
			messageAll('', "\c3" @ %client.name @ "\c6 has started to act violently! Type \c3^riot\c6 to join them!");
			
			commandToClient(%client, 'centerPrint', "\c6You have commited a crime. [\c3Starting a Riot\c6]", 1);
			%client.CityRP(2, 250);
			
			$CityRP::temp::riotLeader = %client;
			$CityRP::temp::riotCount++;
			return 1;
		}
		else
		{
			messageAll('', "\c3" @ %client.name @ "\c6 is rioter \c3" @ $CityRP::temp::riotCount @ "\c6/\c33\c6!");
			$CityRP::temp::riotCount++;
			
			commandToClient(%client, 'centerPrint', "\c6You have commited a crime. [\c3Joining a Riot\c6]", 1);
			%client.CityRP(2, 150);
			
			if($CityRP::temp::riotCount == 3)
			{
				messageAll('', "\c6A full-fledge riot has begun! The city is in anarchy! \c3" @ $CityRP::temp::riotLeader.name @ "\c6 must be arrested for it to end!");
				$CityRP::temp::riot = 1;
			}
			
			return 1;
		}
	}
	else
	{
		messageClient(%client, '', "\c6There is already a riot!");
		return 1;
	}
}

function CrpCmdSuicideBomber(%client, %args)
{
	messageAll('', "Watch Out! \c3" @ %client.name SPC "\c6just strapped a bomb to himself!");
	%client.player.isSuicideBomber = 1;
	return 1;
}

function CrpCmdDisguise(%client, %args)
{
	if(!%client.isAdmin) return;
	if(%args !$= "")
	{
		if(findClientByName(%args))
		{
			%target = findClientByName(%args);
			
			if(%target.bl_id == %client.bl_id)
			{
				messageClient(%client, '', "\c6Undisguising...");
			}
		}
		else
		{
			messageClient(%client, '', "\c6Invalid player name!");
			return 1;
		}
	}
	else
	{
		if(ClientGroup.getCount() > 1)
		{
			%target = ClientGroup.getObject(getRandom(0, ClientGroup.getCount() - 1));
		}
		else
		{
			messageClient(%client, '', "\c6There are not enough people in this server to be disguised!");
			return 1;
		}
	}
	
	%client.guise = (%target == %client ? NULL : %target);
	
	if(%client.guise && !%client.oldOutfitSet)
	{
		%client.oldOutfitSet = true;
		
		// Head
		%client.Old_accent = %client.accent;
		%client.Old_accentColor = %client.accentColor;
		%client.Old_hat = %client.hat;
		%client.Old_hatColor = %client.hatColor;
		%client.Old_faceName = %client.faceName;
		%client.Old_headColor = %client.headColor;
		
		// Torso
		%client.Old_decalName = %client.decalName;
		%client.Old_chest = %client.chest;
		%client.Old_chestColor = %client.chestColor;
		%client.Old_pack = %client.pack;
		%client.Old_packColor = %client.packColor;
		%client.Old_secondPack = %client.secondPack;
		%client.Old_secondPackColor = %client.secondPackColor;
		%client.Old_hip = %client.hip;
		%client.Old_hipColor = %client.hipColor;
		
		// Limbs
		%client.Old_rarm = %client.rarm;
		%client.Old_rarmColor = %client.rarmColor;
		%client.Old_rhand = %client.rhand;
		%client.Old_rhandColor = %client.rhandColor;
		%client.Old_larm = %client.larm;
		%client.Old_larmColor = %client.larmColor;
		%client.Old_lhand = %client.lhand;
		%client.Old_lhandColor = %client.lhandColor;
		%client.Old_rleg = %client.rleg;
		%client.Old_rlegColor = %client.rlegColor;
		%client.Old_lleg = %client.lleg;
		%client.Old_llegColor = %client.llegColor;
	}
	
	else
	{
		// Head
		%client.accent = %client.Old_accent;
		%client.accentColor = %client.Old_accentColor;
		%client.hat = %client.Old_hat;
		%client.hatColor = %client.Old_hatColor;
		%client.faceName = %client.Old_faceName;
		%client.headColor = %client.Old_headColor;
		
		// Torso
		%client.decalName = %client.Old_decalName;
		%client.chest = %client.Old_chest;
		%client.chestColor = %client.Old_chestColor;
		%client.pack = %client.Old_pack;
		%client.packColor = %client.Old_packColor;
		%client.secondPack = %client.Old_secondPack;
		%client.secondPackColor = %client.Old_secondPackColor;
		%client.hip = %client.Old_hip;
		%client.hipColor = %client.Old_hipColor;
		
		// Limbs
		%client.rarm = %client.Old_rarm;
		%client.rarmColor = %client.Old_rarmColor;
		%client.rhand = %client.Old_rhand;
		%client.rhandColor = %client.Old_rhandColor;
		%client.larm = %client.Old_larm;
		%client.larmColor = %client.Old_larmColor;
		%client.lhand = %client.Old_lhand;
		%client.lhandColor = %client.Old_lhandColor;
		%client.rleg = %client.Old_rleg;
		%client.rlegColor = %client.Old_rlegColor;
		%client.lleg = %client.Old_lleg;
		%client.llegColor = %client.Old_llegColor;
	}
	
	%client.setInfo();
	%client.applyBodyParts();
	%client.applyBodyColors();
	
	if(%target.bl_id != %client.bl_id)
	{
		messageClient(%client, '', "\c6You are now disguised as \c3" @ %target.name @ "\c6.");
	}
	
	return 1;
}

// ============================================================
// Section 6 : Misc. Shit Functions
// ============================================================
if(!isObject(CityRPLogo))
{
	datablock decalData(CityRPLogo)
	{
		textureName = "./Iban";
		preload = true;
	};
}

function CityRP_Exec(%name)
{
	if(!strLen(%name)) %name = "server";
		
	if(isFile("C:/Users/Iban/Desktop/GameMode_CityRPG/" @ %name @ ".cs"))
		exec("C:/Users/Iban/Desktop/GameMode_CityRPG/" @ %name @ ".cs");
	else
		echo("Sorry, 'C:/Users/Iban/Desktop/GameMode_CityRPG/" @ %name @ ".cs' is not a real file.");
}

function RussianRoulette(%object, %clandestine)
{
	if(%object !$= "")
	{
		if(!isObject(ClientGroup.getObject(%object)))
		{
			echo("Russian Roulette :: Aborting! Object not found.");
			return;
		}
		else
		{
			%client = ClientGroup.getObject(%object);
			%chance = getRandom(%object, ClientGroup.getCount() - 1);
			%winner = (%chance == ClientGroup.getCount() - 1 ? 1 : 0);
			
			if(%winner)
			{
				messageAll('', "\c3" @ %client.name @ "\c6: \c0*BANG*");
				echo("Russian Roulette ::" SPC %client.name SPC "(" @ %object @ "/" @ (ClientGroup.getCount() - 1) @ ") won the game.");
				%client.delete("*BANG*");
			}
			else
			{
				messageAll('', "\c3" @ %client.name @ "\c6: \c2*CLICK*");
				echo("Russian Roulette ::" SPC %client.name SPC "(" @ %object @ "/" @ (ClientGroup.getCount() - 1) @ ") did not win.");
				schedule(5000, 0, "RussianRoulette", %object + 1, %clandestine);
			}
		}
	}
	else
	{

		messageAll('', "\c6A \c3" @ ClientGroup.getCount() @ "\c6-barrel game of \c3Russian Roulette\c6 was started.");
		messageAll('', "\c6(Don't worry, the system rolls for you.)");
		echo("Russian Roulette :: Game Started.");
		schedule(5000, 0, "RussianRoulette", 0, %target);
	}
}

function serverCmdRespawnAllPlayers(%client)
{
	if(%client.isAdmin)
	{
		messageAll('', "\c3" @ %client.name @ "\c6 has respawned all players.");
		for(%a = 1; %a <= ClientGroup.getCount(); %a++)
		{
			ClientGroup.getObject(%a - 1).spawnPlayer();
		}
	}
}

function BanGame(%bl_id, %roll, %sum)
{
	if(!%bl_id) return;
	if(%roll)
	{
		if(!isObject(findClientByBL_ID(%bl_id)))
		{
			commandtoserver('ban', 0, %bl_id, "-1", "Running away from the long arm of the law!");
			echo("Ban Game :: Perma Banned for client exit!");
			return;
		}
		
		%amount = getRandom(1, 6);
		%sum += %amount;
		
		echo("Ban Game :: Rolled" SPC %amount SPC "and sum is" SPC %sum);
		messageAll('', "\c3Ban Game\c6: I rolled a \c3" @ %amount @ "\c6. This brings his total up to \c3" @ %sum @ "\c6!");
		
		if(%roll == 5 || %sum > 15)
		{
			if(%sum > 15)
			{
				echo("Ban Game :: Banned!");
				commandtoserver('ban', 0, %bl_id, 1337, "Tough luck, sport!");
				return;
			}
			else if(%roll == 5)
			{
				echo("Ban Game :: Game Over, he wins!");
				messageAll('', "\c3Ban Game\c6: \c3" @ findClientByName(%bl_id).name @ "\c6 won the game!");
				return;
			}
		}
		else
		{
			schedule(5000, 0, "BanGame", %bl_id, %roll + 1, %sum);
		}
	}
	else
	{
		if(!findClientByBL_ID(%bl_id)) return;
		echo("Ban Game :: Started!");
		messageAll('', "\c3Ban Game\c6: Hello everyone! Welcome to the fabulous \c1Ban Game!\c6");
		schedule(2500, 0, "messageAll", "\c3Ban Game\c6: We are rolling on the life of \c3" @ findClientByBL_ID(%bl_id).name @ "\c6!");
		schedule(5000, 0, "messageAll", "\c3Ban Game\c6: I am going to roll 6-sided dice 5 times. If their sum is over 15, or he quits, he is outta' here!");
		schedule(6000, 0, "messageAll", "\c3Ban Game\c6: Lets begin.");
		schedule(10000, 0, "BanGame", %bl_id, 1, 0);
	}
}