// ============================================================
// Project				:	peopleRP
// Author				:	Iban
// Description			:	Policeman Code file
// ============================================================
// Table of Contents
// 1. Preferences
// 2. Job Tool
// 2.1 Datablocks
// 2.2 Visual Fuctionality
// 2.3 Functions
// ============================================================

// ============================================================
// Section 1 : Preferences
// ============================================================
if(!$CityRP__HasBuiltJobs || !isFile("config/server/IbanMod/CityRPG/Prefs.cs") || $CityRP::temp::rebuildPref)
{
	$CityRP::jobs::name[$CityRP::jobs++] = "Policeman";
	$CityRP::jobs::initialInvestment[$CityRP::jobs] = 125;
	$CityRP::jobs::pay[$CityRP::jobs] = 50;
	$CityRP::jobs::tools[$CityRP::jobs] = "CityRPBatonItem";
	$CityRP::jobs::items[$CityRP::jobs] = false;
	$CityRP::jobs::law[$CityRP::jobs] = true;
	$CityRP::jobs::canPardon[$CityRP::jobs] = false;
	
	$CityRP::jobs::thief[$CityRP::jobs] = false;
	$CityRP::jobs::drugPusher[$CityRP::jobs] = false;
	$CityRP::jobs::hideJobName[$CityRP::jobs] = false;
	
	$CityRP::jobs::tmHexColor[$CityRP::jobs] = "99FF00";
	
	$CityRP::jobs::bounty::Offerer[$CityRP::jobs] = false;
	$CityRP::jobs::bounty::Claimer[$CityRP::jobs] = true;
	
	$CityRP::jobs::labor[$CityRP::jobs] = false;
	
	$CityRP::jobs::helpline[$CityRP::jobs] = "\c6Police can arrest criminals, kill wanted men, and bust down doors, but require a clean record.";
}
					
// ============================================================
// Section 2 : Job Tool
// ============================================================

// Secton 2.1 : Datablocks
datablock projectileData(CityRPBatonProjectile : hammerProjectile)
{
	directDamage = 0;
	lifeTime = 150;
	explodeOnDeath = false;
	
	canArrest = true;
	canBurnDrugs = true;
	
	canOpenDoors = true;
	openCondition = "legal";
};

datablock itemData(CityRPBatonItem : hammerItem)
{
	uiName = "Baton";
	noSpawn = true;
	isLawEnforcement = true;
	image = CityRPBatonImage;
	colorShiftColor = "0.898039 0.898039 0.000000 1.000000";
};

datablock shapeBaseImageData(CityRPBatonImage : hammerImage)
{
	item = CiyRPBatonItem;
	projectile = CityRPBatonProjectile;
	colorShiftColor = "0.898039 0.898039 0.000000 1.000000";
};

// Section 2.2 : Visual Functionality
function CityRPBatonImage::onFire(%this, %obj, %slot)
{
	parent::onFire(%this, %obj, %slot);
	
	%obj.playThread(2, "armAttack");
}

function CityRPBatonImage::onStopFire(%this, %obj, %slot)
{
	%obj.playThread(2, "root");
}

// Section 2.3 : Functions
package CityRP_PolicePackage
{
	function CityRPBatonProjectile::onCollision(%this, %obj, %col, %fade, %pos, %normal)
	{
		ProjectileData::onCollision(%this, %obj, %col, %fade, %pos, %normal);
		serverPlay3D(hammerHitSound, %pos);
	}
};
activatePackage(CityRP_PolicePackage);