// ============================================================
// Project				:	peopleRP
// Author				:	Iban
// Description			:	Criminal Code file
// ============================================================
// Table of Contents
// 1. Preferences
// 2. Job Tool
// 2.1 Datablocks
// 2.2 Visual Fuctionality
// 2.3 Functions
// ============================================================

// ============================================================
// Section 1 : Preferences
// ===========================================================
if(!$CityRP__HasBuiltJobs || !isFile("config/server/IbanMod/CityRPG/Prefs.cs") || $CityRP::temp::rebuildPref)
{
	$CityRP::jobs::name[$CityRP::jobs++] = "Criminal";
	$CityRP::jobs::initialInvestment[$CityRP::jobs] = 200;
	$CityRP::jobs::pay[$CityRP::jobs] = 40;
	$CityRP::jobs::tools[$CityRP::jobs] = "CityRPPicklockItem";
	$CityRP::jobs::items[$CityRP::jobs] = false;
	$CityRP::jobs::law[$CityRP::jobs] = false;
	$CityRP::jobs::canPardon[$CityRP::jobs] = false;
	
	$CityRP::jobs::thief[$CityRP::jobs] = true;
	$CityRP::jobs::drugPusher[$CityRP::jobs] = false;
	$CityRP::jobs::hideJobName[$CityRP::jobs] = true;
	
	$CityRP::jobs::tmHexColor[$CityRP::jobs] = "FF0000";
	
	$CityRP::jobs::bounty::Offerer[$CityRP::jobs] = false;
	$CityRP::jobs::bounty::Claimer[$CityRP::jobs] = false;
	
	$CityRP::jobs::labor[$CityRP::jobs] = false;
	
	$CityRP::jobs::helpline[$CityRP::jobs] = "\c6Criminals can pickpocket people and break open doors.";
}

// ============================================================
// Section 2 : Job Tool
// ============================================================

// Secton 2.1 : Datablocks
datablock projectileData(CityRPPicklockProjectile : hammerProjectile)
{
	directDamage = 0;
	lifeTime = 150;
	explodeOnDeath = false;
	
	canOpenDoors = true;
	openCondition = "illegal";
};

datablock itemData(CityRPPicklockItem : hammerItem)
{
	uiName = "Lockpick";
	noSpawn = true;
	image = CityRPPicklockImage;
	colorShiftColor = "0.650000 0.000000 0.000000 1.000000";
};

datablock shapeBaseImageData(CityRPPicklockImage : hammerImage)
{
	item = CiyRPPicklockItem;
	projectile = CityRPPicklockProjectile;
	colorShiftColor = "0.650000 0.000000 0.000000 1.000000";
};

// Section 2.2 : Visual Functionality
function CityRPPicklockImage::onFire(%this, %obj, %slot)
{
	parent::onFire(%this, %obj, %slot);
	%obj.playThread(2, "armAttack");
}

function CityRPPicklockImage::onStopFire(%this, %obj, %slot)
{
	%obj.playThread(2, "root");
}

// Section 2.3 : Functions
package CityRP_CriminalPackage
{
	function CityRPPicklockProjectile::onCollision(%this, %obj, %col, %fade, %pos, %normal)
	{
		ProjectileData::onCollision(%this, %obj, %col, %fade, %pos, %normal);
		serverPlay3D(hammerHitSound, %pos);
	}
	
	function player::activateStuff(%this)
	{
		parent::activateStuff(%this);
		
		%target = containerRayCast(%this.getEyePoint(), vectorAdd(vectorScale(vectorNormalize(%this.getEyeVector()), 2.5), %this.getEyePoint()), $TypeMasks::All);
		
		if(%this.lastPickpocket + 5 < $sim::time)
		{
			if(%this.client != %target.client && isObject(%target.client) && %target.getClassName() $= "Player")
			{
				if(getWord(CityRPData.getData(%this.client.bl_id).valueJailData, 1) < 1 && getWord(CityRPData.getData(%target.client.bl_id).valueJailData, 1) < 1)
				{
					if($CityRP::jobs::thief[CityRPData.getData(%this.client.bl_id).valueJobID] && CityRPData.getData(%target.client.bl_id).valueMoney > 0)
					{
						%this.lastPickpocket = $sim::time;
				
						%money = CityRPData.getData(%target.client.bl_id).valueMoney;
						if(%money >= 100) { %maxValue = 6; }
						else if(%money >= 50) { %maxValue = 5; }
						else if(%money >= 20) { %maxValue = 4; }
						else if(%money >= 10) { %maxValue = 3; }
						else if(%money >= 5) { %maxValue = 2; }
						else { %maxValue = 1; }
						
						%billStolen = mFloor(getRandom(1, %maxValue));
						
						switch(%billStolen)
						{
							case 1: %theft = 1;
							case 2: %theft = 5;
							case 3: %theft = 10;
							case 4: %theft = 20;
							case 5: %theft = 50;
							case 6: %theft = 100;
						}
						
						CityRPData.getData(%this.client.bl_id).valueMoney += %theft;
						CityRPData.getData(%target.client.bl_id).valueMoney -= %theft;
						
						commandToClient(%this.client, 'centerPrint', "\c6You have commited a crime. [\c3Pickpocketing\c6]", 3);
						%this.client.CityRP(2, $CityRP::demerits::pickpocketing);
						
						messageClient(%this.client, '', "\c6You have stolen a \c3$" @ %theft @ "\c6 bill from\c3" SPC (%target.client.guise ? %target.client.guise.name : %target.client.name) @ "\c6.");
						messageClient(%target.client, '', "\c6You have been pick-pocketed by \c3" @ (CityRPData.getData(%this.client.bl_id).valueDemerits >= $CityRP::pref::demerits::wantedLevel ? (%this.client.guise ? %this.client.guise.name : %this.client.name) : "Someone") @ "\c6!");
						
						%this.client.SetInfo();
						%target.client.SetInfo();
					}
				}
			}
		}
	}
};
activatePackage(CityRP_CriminalPackage);