// ============================================================
// Project				:	peopleRP
// Author				:	Iban
// Description			:	Bounty Hunter Code file
// ============================================================
// Table of Contents
// 1. Preferences
// 2. Job Tool
// 2.1 Datablocks
// 2.2 Visual Fuctionality
// 2.3 Functions
// ============================================================

// ============================================================
// Section 1 : Preferences
// ============================================================
if(!$CityRP__HasBuiltJobs || !isFile("config/server/IbanMod/CityRPG/Prefs.cs") || $CityRP::temp::rebuildPref)
{
	$CityRP::jobs::name[$CityRP::jobs++] = "Bounty Hunter";
	$CityRP::jobs::initialInvestment[$CityRP::jobs] = 100;
	$CityRP::jobs::pay[$CityRP::jobs] = 25;
	$CityRP::jobs::tools[$CityRP::jobs] = "CityRPLBItem";
	$CityRP::jobs::items[$CityRP::jobs] = false;
	$CityRP::jobs::law[$CityRP::jobs] = false;
	$CityRP::jobs::canPardon[$CityRP::jobs] = false;
	
	$CityRP::jobs::thief[$CityRP::jobs] = false;
	$CityRP::jobs::drugPusher[$CityRP::jobs] = false;
	$CityRP::jobs::hideJobName[$CityRP::jobs] = false;
	
	$CityRP::jobs::tmHexColor[$CityRP::jobs] = "FF7F00";
	
	$CityRP::jobs::bounty::Offerer[$CityRP::jobs] = false;
	$CityRP::jobs::bounty::Claimer[$CityRP::jobs] = true;
	
	$CityRP::jobs::labor[$CityRP::jobs] = false;
	
	$CityRP::jobs::helpline[$CityRP::jobs] = "\c6Bounty Hunters can arrest criminals and claim bounties, but don't need a good record.";
}

// ============================================================
// Section 2 : Job Tool
// ============================================================

// Secton 2.1 : Datablocks
datablock projectileData(CityRPLBProjectile : hammerProjectile)
{
	directDamage = 0;
	lifeTime = 150;
	explodeOnDeath = false;
	
	canArrest = true;
	canBurnDrugs = true;
	
	canOpenDoors = true;
	openCondition = "legal";
};

datablock itemData(CityRPLBItem : hammerItem)
{
	uiName = "Limited-Baton";
	noSpawn = true;
	isLawEnforcement = true;
	image = CityRPLBImage;
	colorShiftColor = "0.650000 0.650000 0.000000 1.000000";
};

datablock shapeBaseImageData(CityRPLBImage : hammerImage)
{
	item = CiyRPLBItem;
	projectile = CityRPLBProjectile;
	colorShiftColor = "0.650000 0.650000 0.000000 1.000000";
};

// Section 2.2 : Visual Functionality
function CityRPLBImage::onFire(%this, %obj, %slot)
{
	parent::onFire(%this, %obj, %slot);
	
	%obj.playThread(2, "armAttack");
}

function CityRPLBImage::onStopFire(%this, %obj, %slot)
{
	%obj.playThread(2, "root");
}

// Section 2.3 : Functions
package CityRP_BHPackage
{
	function CityRPLBProjectile::onCollision(%this, %obj, %col, %fade, %pos, %normal)
	{
		ProjectileData::onCollision(%this, %obj, %col, %fade, %pos, %normal);
		serverPlay3D(hammerHitSound, %pos);
	}
};
activatePackage(CityRP_BHPackage);