// ============================================================
// Project				:	CityRP
// Author				:	Iban
// Description			:	Drop-Cash-On-Death Module Code File
// ============================================================
// Table of Contents
// 1. Package Data
// 1.1. Drop Money
// 1.2. Money Pickup
// 2. Money Datablock
// ============================================================

// ============================================================
// Section 1 : Package Data
// ============================================================
package CityRP_Cash
{
	// Section 1.1 : Drop Money
	function gameConnection::onDeath(%this, %killerPlayer, %killer, %damageType, %unknownA)
	{
		if(CityRPData.getData(%this.bl_id).valueMoney > 0)
		{
			%cash = new Item()
			{
				datablock = cashItem;
				canPickup = false;
				value = mFloor(CityRPData.getData(%this.bl_id).valueMoney);
			};
			%cash.setTransform(setWord(%this.player.getTransform(), 2, getWord(%this.player.getTransform(), 2) + 2));
			%cash.setVelocity(VectorScale(%this.player.getEyeVector(), 10));
			
			MissionCleanup.add(%cash);
			
			%cash.setShapeName("$" @ %cash.value);
			
			CityRPData.getData(%this.bl_id).valueMoney = 0;
			
			%this.SetInfo();
		}
		
		parent::onDeath(%this, %killerPlayer, %killer, %damageType, %unknownA);
	}
	
	// Section 1.2 : Money Pickup
	function Armor::onCollision(%this, %obj, %col, %thing, %other)
	{
		if(%col.getDatablock().getName() $= "CashItem")
		{
			if(isObject(%obj.client))
			{
				if(isObject(%col))
				{
					if(%obj.client.minigame)
					{
						%col.minigame = %obj.client.minigame;
					}
					
					CityRPData.getData(%obj.client.bl_id).valueMoney += %col.value;
					messageClient(%obj.client, '', "\c6You have picked up \c3$" @ %col.value SPC "\c6off the ground.");
					
					%obj.client.SetInfo();
					%col.canPickup = false;
					%col.delete();
					
					return;
				}
				else
				{
					%col.delete();
					MissionCleanup.remove(%col);
				}
			}
		}
		else
		{
			Parent::onCollision(%this, %obj, %col, %thing, %others);
		}
	}
	
	function CashItem::onAdd(%this, %item, %b, %c, %d, %e, %f, %g)
	{
		parent::onAdd(%this, %item, %b, %c, %d, %e, %f, %g);
		%item.schedule(10000, "delete");
	}
};
activatePackage(CityRP_Cash);

// ============================================================
// Section 2 : Money Datablock
// ============================================================
datablock ItemData(cashItem)
{
	category = "Weapon";
	className = "Weapon";
	
	shapeFile = "base/data/shapes/brickWeapon.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;
	
	doColorShift = true;
	colorShiftColor = "0 0.6 0 1";
	image = cashImage;
	candrop = true;
	canPickup = false;
};

datablock ShapeBaseImageData(cashImage)
{
	shapeFile = "base/data/shapes/brickWeapon.dts";
	emap = true;
	
	doColorShift = true;
	colorShiftColor = cashItem.colorShiftColor;
	canPickup = false;
};