// ============================================================
// Project				:	CityRP
// Author				:	Jookia & Iban
// Description			:	Code that overwrites main functions of Blockland.
// ============================================================
// Table of Contents
// 1. Brick Overloads
// 2. Client Overloads
// 3. Player Overloads
// 4. Misc. Overloads
// 5. Chat Overloads/Functions
// 6. CrpCmds
// ============================================================

package CityRP_MainPackage
{
	// ============================================================
	// Section 1 : Brick Overloads
	// ============================================================
	function fxDTSBrick::onDeath(%brick)
	{
		switch(%brick.getDatablock().CityRPBrickType)
		{
			case 1:
				%brick.CityRP(2);
			case 2:
				%brick.CityRP(2);
			case 3:
				if(getWord($CityRP::temp::spawnPoints, 0) == %brick)
				{
					$CityRP::temp::spawnPoints = strReplace($CityRP::temp::spawnPoints, %brick @ " ", "");
				}
				else
				{
					$CityRP::temp::spawnPoints = strReplace($CityRP::temp::spawnPoints, " " @ %brick, "");
				}
		}
		
		parent::onDeath(%brick);
	}
	
	function fxDtsBrick::onPlant(%brick)
	{
		parent::onPlant(%brick);
		
		if(isObject($loadingBricks_client) && !isObject($loadBrick_fileObj))
		{
			if(%brick.getDatablock().CityRPBrickType == 1 || %brick.getDatablock().CityRPBrickType == 2)
			{
				%brick.schedule(1, "CityRP", 1);
			}
			
			if(%brick.getDatablock().CityRPBrickType == 3)
			{
				$CityRP::temp::spawnPoints = ($CityRP::temp::spawnPoints $= "") ? %brick : $CityRP::temp::spawnPoints SPC %brick;
			}
			
			if(%brick.getDatablock().CityRPBrickType == 4)
			{
				if(%brick.getDatablock().resources)
				{
					%brick.resources = %brick.getDatablock().resources;
				}
			}
			
			return;
		}
		
		if(!isObject(getBrickGroupFromObject(%brick).client))
		{
			if(%brick.getDatablock().CityRPBrickType == 1)
			{
				%brick.schedule(0, "delete");
			}
			
			if(%brick.getDatablock().CityRPBrickType == 2)
			{
				%brick.schedule(0, "CityRP", 1);
			}
			
			if(%brick.getDatablock().CityRPBrickType == 3)
			{
				$CityRP::temp::spawnPoints = ($CityRP::temp::spawnPoints $= "") ? %brick : $CityRP::temp::spawnPoints SPC %brick;
			}
			
			if(%brick.getDatablock().CityRPBrickType == 4)
			{
				if(%brick.getDatablock().resources)
				{
					%brick.resources = %brick.getDatablock().resources;
				}
			}
			
			return;
		}
		
		%boxSize = getWord(%brick.getDatablock().brickSizeX, 1) / 2.5 SPC getWord(%brick.getDatablock().brickSizeY, 0) / 2.5 SPC getWord(%brick.getDatablock().brickSizeZ, 2) / 2.5;
		
		if(mFloor(getWord(%brick.rotation, 3)) == 90)
		{
			%boxSize = getWord(%brick.getDatablock().brickSizeY, 1) / 2.5 SPC getWord(%brick.getDatablock().brickSizeX, 0) / 2.5 SPC getWord(%brick.getDatablock().brickSizeZ, 2) / 2.5;
		}
		
		%client = getBrickGroupFromObject(%brick).client;
		
		initContainerBoxSearch(%brick.getWorldBoxCenter(), %boxSize, $typeMasks::triggerObjectType);
		
		while(isObject(%potentialTrigger = containerSearchNext()))
		{
			%trigger = %potentialTrigger;
			
			if(%trigger.getDatablock() == CityRPLotTriggerData.getID())
			{
				if(%brick.getDatablock().CityRPBrickType == 1)
				{
					%brick.schedule(0, "delete");
					
					return;
				}
				
				if(getTrustLevel(%trigger.parent, %client.player) < 1)
				{
					commandToClient(%client, 'centerPrint', (getBrickGroupFromObject(%trigger.parent).name $= "") ? "\c1BL_ID:" SPC getBrickGroupFromObject(%trigger.parent).bl_id : getBrickGroupFromObject(%trigger.parent).name SPC "\c0does not trust you enough to do that.", 1);
					
					%brick.schedule(0, "delete");
					
					return;
				}
			}
		}
		
		if(!%client.isAdmin && %brick.getDatablock().CityRPBrickAdmin)
		{
			commandToClient(%client, 'centerPrint', "\c3You must be admin to plant this brick!", 3);
			
			%brick.schedule(0, "delete");
			
			return;
		}
		
		if(!%client.isAdmin && !isObject(%trigger) && %brick.getDatablock().CityRPBrickType != 1)
		{
			%brick.schedule(0, "delete");
			
			return;
		}
		
		if(%brick.getDatablock().CityRPBrickType == 1)
		{
			if(CityRPData.getData(%client.bl_id).valueMoney < mFloor(%brick.getDatablock().initialPrice))
			{
				messageClient(%client, '', "\c6You need at least \c3$" @ mFloor(%brick.getDatablock().initialPrice) SPC "\c6in order to plant this lot!");
				
				%brick.schedule(0, "delete");
				
				return;
			}
			
			messageClient(%client, '', "\c6You have paid \c3$" @ mFloor(%brick.getDatablock().initialPrice) @ "\c6 to plant this lot.");
			
			CityRPData.getData(%client.bl_id).valueMoney -= mFloor(%brick.getDatablock().initialPrice);
		}
		
		if(!isObject(CityRPData.getData(getBrickGroupFromObject(%brick).bl_id)))
		{
			CityRPData.addData(getBrickGroupFromObject(%brick).bl_id);
		}
		
		if(%brick.getDatablock().brickType == 2)
		{
			if(CityRPData.getData(%client.bl_id).valueMoney < mFloor($CityRP::prices::vehicleSpawn))
			{
				messageClient(%client, '', "\c6You need at least \c3$" @ mFloor($CityRP::prices::vehicleSpawn) SPC "\c6in order to plant this vehicle spawn!");
				
				%brick.schedule(0, "delete");
				
				return;
			}
			
			messageClient(%client, '', "\c6You have paid \c3$" @ mFloor($CityRP::prices::vehicleSpawn) @ "\c6 to plant this vehicle spawn.");
			
			CityRPData.getData(%client.bl_id).valueMoney -= mFloor($CityRP::prices::vehicleSpawn);
		}
		
		if(%brick.getDatablock().CityRPBrickType == 1 || %brick.getDatablock().CityRPBrickType == 2)
		{
			%brick.schedule(0, "CityRP", 1);
		}
		else if(%brick.getDatablock().CityRPBrickType == 3)
		{
			$CityRP::temp::spawnPoints = ($CityRP::temp::spawnPoints $= "") ? %brick : $CityRP::temp::spawnPoints SPC %brick;
		}
		
		if(%brick.getDatablock().CityRPBrickType == 4)
		{
			if(%brick.getDatablock().resources)
			{
				%brick.resources = %brick.getDatablock().resources;
			}
		}
		
		%client.CityRP(1);
	}	

	
	function fxDTSBrick::onRemove(%brick)
	{
		switch(%brick.getDatablock().CityRPBrickType)
		{
			case 1:
				%brick.CityRP(2);
			case 2:
				%brick.CityRP(2);
			case 3:
				if(getWord($CityRP::temp::spawnPoints, 0) == %brick)
				{
					$CityRP::temp::spawnPoints = strReplace($CityRP::temp::spawnPoints, %brick @ " ", "");
				}
				else
				{
					$CityRP::temp::spawnPoints = strReplace($CityRP::temp::spawnPoints, " " @ %brick, "");
				}
		}
		
		parent::onRemove(%brick);
	}
	
	function fxDTSBrick::setItem(%brick, %datablock, %client)
	{
		if(!%brick.getDatablock().CityRPPermaspawn && (!isObject($loadingBricks_client) || isObject($loadBrick_fileObj)))
		{
			if(!isObject(%brick.item) || %brick.item.getDatablock() != %datablock)
			{
				%ownerBG = getBrickGroupFromObject(%brick);
				
				if(!isObject(%datablock) || (!%ownerBG.client.isAdmin && $CityRP::jobs::items[CityRPData.getData(%ownerBG.bl_id).valueJobID] == false))
				{
					if(isObject(%datablock) && %client)
					{
						messageClient(%client, '', "\c6The owner of this service cannot spawn items.");
					}
					
					parent::setItem(%brick, 0, %client);
					return;
				}
				
				if(%datablock.noSpawn && !%client.isAdmin)
				{
					messageClient(%client, '', "\c6This item cannot be spawned.");
					return;
				}
				
				if(!CityRP_BuyItem(%ownerBG.bl_id, %datablock.image))
				{
					return;
				}
			}
		}
		
		parent::setItem(%brick, %datablock, %client);
	}
	
	function fxDTSBrick::spawnItem(%brick, %pos, %datablock, %client)
	{		
		if(!isObject(%client))
		{
			return;
		}
		
		if(!isObject(%datablock) || (!%client.isAdmin && $CityRP::jobs::items[CityRPData.getData(%client.bl_id).valueJobID] == false))
		{
			return;
		}
		
		if(%datablock.noSpawn && !%client.isAdmin)
		{
			return;
		}
		
		if(!%client.BuyItem(%datablock.image))
		{
			return;
		}
		
		parent::spawnItem(%brick, %pos, %datablock, %client);
	}
	
	function fxDTSBrick::setVehicle(%brick, %vehicle)
	{
		if(!isObject(%brick.getGroup().client) || !%brick.getGroup().client.isAdmin)
		{
			if(isObject(%vehicle))
			{
				for(%a = 0; $CityRP::vehicles::banned[%a] !$= "" && !%hasBeenBanned; %a++)
				{
					if(%vehicle.getName() $= $CityRP::vehicles::banned[%a])
					{
						if(isObject(%brick.getGroup().client))
						{
							messageClient(%brick.getGroup().client, '', "\c6Standard users may not spawn a\c3" SPC %vehicle.uiName @ "\c6.");
						}
						%vehicle = 0;
						%hasBeenBanned = true;
					}
				}
			}
		}
		
		parent::setVehicle(%brick, %vehicle);
	}
	
	function fxDTSBrick::processInputEvent(%this ,%event, %client)
	{
		$lastProcessedBrick_cityRP = %this;
		Parent::processInputEvent(%this, %event, %client);
	}
	
	function fxDTSBrick::spawnProjectile(%v1, %v2, %v3, %v4, %v5, %v6)
	{
		return;
	}
	
	// ============================================================
	// Section 2 : Client Overloads
	// ============================================================	
	function gameConnection::onClientEnterGame(%this)
	{
		parent::onClientEnterGame(%this);
		
		if(!isObject(CityRPData.getData(%this.bl_id)))
		{
			CityRPData.addData(%this.bl_id);
		}
		
		if(isObject(CityRPMini))
		{
			CityRPMini.addMember(%this);
		}
		else
		{
			CityRP_BuildMinigame();
		}
		
		// I wouldn't do that if I were you...
		centerPrint(%this, "<bitmap:Add-Ons/GameMode_CityRPG/Iban>", 5);
	}
	
	function gameConnection::onClientLeaveGame(%this)
	{
		if(%this.player)
		{
			for(%a = 0; %a < %this.player.getDatablock().maxTools; %a++)
			{
				if(!%tools)
				{
					%tools = %this.player.tool[%a];
				}
				else
				{
					%tools = %tools SPC %this.player.tool[%a];
				}
				
			}
			
			CityRPData.getData(%this.bl_id).valueTools = %tools;
		}
		
		parent::onClientLeaveGame(%this);
	}
	
	function gameConnection::autoAdminCheck(%client)
	{
		parent::autoAdminCheck(%client);
		
		if(isObject(CityRPData.getData(%client.bl_id)))
		{
			if(CityRPData.getData(%client.bl_id).valueDebt > 0)
			{
				messageClient(%client, '', "\c7You have \c31\c7 new message.");
				if(CityRPData.getData(%client.bl_id).valueDebt > 1000)
				{
					messageClient(%client, '', '\c7Message\c6: I\'m not kidding anymore. \c0$%1\c6 ain\'t chump change! Pay this off in the next \c3%2\c6 ticks, or I\'m going to hurt you real, real, bad.', CityRPData.getData(%client.bl_id).valueDebt, $CityRP::pref::demerits::irsBustsYourBalls);
					
					%client.ballBustingTime = 3;
				}
				else if(CityRPData.getData(%client.bl_id).valueDebt > 500)
				{
					messageClient(%client, '', '\c7Message\c6: Hey, buddy. You\'re busting my balls here. Pay off this \c0$%1\c6 of debt before I bust yours.', CityRPData.getData(%client.bl_id).valueDebt);
				}
				else
				{
					messageClient(%client, '', '\c7Message\c6: Hi, this is Tom with the IRS. Did you know that you have \c0$%1\c6 in debt? Please try and pay this off soon, thanks!', CityRPData.getData(%client.bl_id).valueDebt);
				}
			}
		}
	}
	
	function gameConnection::spawnPlayer(%this)
	{
		parent::spawnPlayer(%this);
		
		%client.hasBeenDead = 0;
		
		if(isObject(%this.CityRPTrigger))
		{
			%this.CityRPTrigger.getDatablock().onLeaveTrigger(%this.CityRPTrigger, %this.player);
		}
		
		%this.SetInfo();
		
		if(CityRP_FindSpawn("jobSpawn", 1) && CityRPData.getData(%this.bl_id).valueJobID != 1)
		{
			%spawn = CityRP_FindSpawn("jobSpawn", 1);
		}
		
		if(CityRP_FindSpawn("jobSpawn", CityRPData.getData(%this.bl_id).valueJobID))
		{
			%spawn = CityRP_FindSpawn("jobSpawn", CityRPData.getData(%this.bl_id).valueJobID);
		}
		
		if(CityRP_FindSpawn("personalSpawn", %this.bl_id))
		{
			%spawn = CityRP_FindSpawn("personalSpawn", %this.bl_id);
		}
		
		if(getWord(CityRPData.getData(%this.bl_id).valueJailData, 1) > 0 && CityRP_FindSpawn("jailSpawn"))
		{
			%spawn = CityRP_FindSpawn("jailSpawn");
		}
		
		if(%spawn !$= "")
		{
			%this.player.setTransform(%spawn);
		}
		
		%this.player.giveDefaultEquipment();
	}
	
	function gameConnection::onDeath(%this, %killerPlayer, %killer, %damageType, %unknownA)
	{
		if(getWord(CityRPData.getData(%this.bl_id).valueJailData, 1) < 1)
		{
			if(%this.player.currTool)
			{
				serverCmddropTool(%this, %this.player.currTool);
			}
		}
		
		CityRPData.getData(%this.bl_id).valueTools = "";
		
		if(isObject(%killer) && %killer != %this)
		{
			if(CityRPData.getData(%this.bl_id).valueBounty > 0)
			{
				if(!$CityRP::jobs::bounty::Claimer[CityRPData.getData(%killer.bl_id).valueJobID])
				{
					commandToClient(%killer, 'centerPrint', "\c6You have commited a crime. [\c3Claiming a Hit\c6]", 1);
					%killer.CityRP(2, $CityRP::demerits::bountyClaiming);
				}
				
				messageClient(%killer, '', "\c6Hit was completed successfully. The money has been wired to your bank account.");
				CityRPData.getData(%killer.bl_id).valueBank += CityRPData.getData(%this.bl_id).valueBounty;
				CityRPData.getData(%this.bl_id).valueBounty = 0;
			}
			else
			{
				if(CityRPData.getData(%this.bl_id).valueDemerits < $CityRP::pref::demerits::wantedLevel && getWord(CityRPData.getData(%this.bl_id).valueJailData, 1) == 0)
				{
					commandToClient(%killer, 'centerPrint', "\c6You have commited a crime. [\c3Murder\c6]", 1);
					%killer.CityRP(2, $CityRP::demerits::murder);
				}
			}
		}
		
		CityRPData.getData(%this.bl_id).valueTools = "";
		parent::onDeath(%this, %player, %killer, %damageType, %unknownA);
	}
		
	function gameConnection::applyBodyParts(%client)
	{
		if(%client.guise)
		{
			if(isObject(%client))
			{
				%target = findClientByBL_ID(%client.guise.bl_id);
				
				if(%target)
				{
					%client.accent = %target.accent;
					%client.hat = %target.hat;
					%client.faceName = %target.faceName;
					
					%client.decalName = %target.decalName;
					%client.secondPack = %target.secondPack;
					%client.hip = %target.hip;
					%client.chest = %target.chest;
					%client.pack = %target.pack;
					
					%client.lleg = %target.lleg;
					%client.rleg = %target.rleg;
					%client.lhand = %target.lhand;
					%client.larm = %target.larm;
					%client.rarm = %target.rarm;
					%client.rhand = %target.rhand;
				}
			}
			else
			{
				%client.guise = NULL;
			}
		}
		
		parent::applyBodyParts(%client);
	}
	
	function gameConnection::applyBodyColors(%client)
	{
		if(%client.guise)
		{
			if(isObject(%client.guise))
			{
				%target = findClientByBL_ID(%client.guise.bl_id);
				
				if(%target)
				{
					%client.accentColor = %target.accentColor;
					%client.hatColor = %target.hatColor;
					%client.headColor = %target.headColor;
					
					%client.chestColor = %target.chestColor;
					%client.packColor = %target.packColor;
					%client.secondPackColor = %target.secondPackColor;
					%client.hipColor = %target.hipColor;
					
					%client.rarmColor = %target.rarmColor;
					%client.rhandColor = %target.rhandColor;
					%client.larmColor = %target.larmColor;
					%client.lhandColor = %target.lhandColor;
					%client.rlegColor = %target.rlegColor;
					%client.llegColor = %target.llegColor;
				}
			}
			else
			{
				%client.guise = NULL;
			}
		}
		
		parent::applyBodyColors(%client);
	}
	
	// ============================================================
	// Section 3 : Player Overloads
	// ============================================================
	function player::playThread(%this, %slot, %thread)
	{
		if(%thread $= "armReadyRight" && getWord(CityRPData.getData(%this.client.bl_id).valueJailData, 1) > 0)
		{
			return;
		}
		
		parent::playThread(%this, %slot, %thread);
	}
	
	function player::mountImage(%this, %datablock, %slot)
	{		
		if(getWord(CityRPData.getData(%this.client.bl_id).valueJailData, 1) > 0 && %datablock.getName() !$= "CityRPLumberjackImage" && %datablock.getName() !$= "CityRPShovelImage")
		{
			return;
		}
		
		parent::mountImage(%this, %datablock, %slot);
	}
	
	function player::setDatablock(%this, %datablock)
	{
		if(%datablock != CityRPMini.playerDatablock.getID())
		{
			return;
		}
		
		parent::setDatablock(%this, %datablock);
	}
	
	function player::damage(%this, %obj, %pos, %damage, %damageType)
	{
		// Test that the people exist.
		if(isObject(%obj) && isObject(%this.client) && isObject(%obj.client))
		{
			// Test that the victim and killer are not the same.
			if(%this != %obj && %this.client != %obj.client)
			{
				// Check to make sure that the damage isn't lethal.
				if(%this.getDamageLevel() + %damage < %this.getDatablock().maxDamage || %this.getDatablock().isHealthPlayer)
				{
					// Check if the person has a bounty.
					if(CityRPData.getData(%this.client.bl_id).valueBounty > 0)
					{
						// If he does, check to see if the person attacking him can legally lay claim to that bounty.
						if($CityRP::jobs::bounty::Claimer[CityRPData.getData(%killer.client.bl_id).valueJobID])
						{
							// If he does, skip the rest.
							parent::damage(%this, %obj, %pos, %damage, %damageType);
							return;
						}
					}
					
					// He's not. Continue the regular tests.
					// Check if the person is wanted.
					if(CityRPData.getData(%this.client.bl_id).valueDemerits < $CityRP::pref::demerits::wantedLevel)
					{
						// See if he is in jail.
						if(getWord(CityRPData.getData(%this.client.bl_id).valueJailData, 1) < 1)
						{
							// Find the driver of the vehicle.
							%client = ((%this.getType() & $typeMasks::vehicleObjectType) && isObject(%obj.getControllingClient())) ? %obj.getControllingClient() : %obj.client;
							
							commandToClient(%client, 'centerPrint', "\c6You have commited a crime. [\c3Assault\c6]", 1);
							
							if(%this.getDatablock().isHealthPlayer)
							{
								%demerits = mFloor($CityRP::demerits::murder * (%damage / (%this.getDatablock().maxHealth + %this.getDatablock().maxEnergy)));
							}
							else
							{
								%demerits = mFloor($CityRP::demerits::murder * (%damage / %this.getDatablock().maxHealth));
							}
							
							if(CityRPData.getData(%client.bl_id).valueDemerits + %demerits < $CityRP::pref::demerits::wantedLevel)
							{
								%demerits =	$CityRP::pref::demerits::wantedLevel - CityRPData.getData(%client.bl_id).valueDemerits;
							}
							
							%client.CityRP(2, %demerits);
						}
					}
				}
			}
		}
		
		parent::damage(%this, %obj, %pos, %damage, %damageType);
	}
	
	function player::setScale(%this, %scale)
	{
		if(%this.client.minigame $= "CityRPMini")
		{
			%scale = "1 1 1";
		}
		parent::setScale(%this, %scale);
	}
	
	function player::spawnProjectile(%v1, %v2, %v3, %v4, %v5, %v6)
	{
		return;
	}
	
	// ============================================================
	// Section 4 : Misc Overloads
	// ============================================================	
	function itemData::onPickup(%this, %item, %obj)
	{
		parent::onPickup(%this, %item, %obj);
		
		if(isObject(%item.spawnBrick))
		{
			if(!%item.spawnBrick.getDatablock().CityRPPermaspawn)
			{
				%item.spawnBrick.setItem(0, ((isObject(getBrickGroupFromObject(%item.spawnBrick).client)) ? getBrickGroupFromObject(%item.spawnBrick).client : 0), true);
			}
		}
	}
	
	function weapon::onPickup(%this, %item, %obj)
	{
		parent::onPickup(%this, %item, %obj);
		
		if(isObject(%item.spawnBrick))
		{
			if(!%item.spawnBrick.getDatablock().CityRPPermaspawn)
			{
				%item.spawnBrick.setItem(0, ((isObject(getBrickGroupFromObject(%item.spawnBrick).client)) ? getBrickGroupFromObject(%item.spawnBrick).client : 0), true);
			}
		}
	}
	
	function ProjectileData::onCollision(%this, %obj, %col, %fade, %pos, %normal)
	{
		parent::onCollision(%this, %obj, %col, %fade, %pos, %normal);
		
		if(%this.canOpenDoors)
		{
			if((%col.getType() & $typeMasks::fxBrickObjectType))
			{
				if(isObject(%col.door))
				{
					if(%this.openCondition $= "legal")
					{
						for(%i = 0; %col.eventInput[%i] !$= "" && !%doorPath; %i++)
						{
							if(%col.eventOutput[%i] $= "doorOpen")
							{
								%doorPath = %col.eventOutputParameter[%i, 2];
							}
						}
						
						if(%doorPath == 0)
						{
							%doorResult = %col.doorOpenCW();
						}
						else if(%doorPath == 1)
						{
							%doorResult = %col.doorOpenCCW();
						}
						else
						{
							%doorResult = %col.doorOpen();
						}
						
						%col.schedule(3000, "doorClose");
						
						if(%doorResult == 1)
						{
							%col.schedule(3000, "doorClose");
						}
						else
						{
							commandToClient(%obj.client, 'centerPrint', "\c6The door is lodged shut!", 3);
						}
					}
					else if(%this.openCondition $= "illegal")
					{
						if(getRandom(0, 3) > 2)
						{
							for(%i = 0; %col.eventInput[%i] !$= "" && !%doorPath; %i++)
							{
								if(%col.eventOutput[%i] $= "doorOpen")
								{
									%doorPath = %col.eventOutputParameter[%i, 2];
								}
							}
							
							if(%doorPath == 0)
							{
								%doorResult = %col.doorOpenCW();
							}
							else if(%doorPath == 1)
							{
								%doorResult = %col.doorOpenCCW();
							}
							else
							{
								%doorResult = %col.doorOpen();
							}
							
							%col.schedule(3000, "doorClose");
							
							if(%doorResult == 1)
							{
								%col.schedule(3000, "doorClose");
								
								commandToClient(%obj.client, 'centerPrint', "\c6You have commited a crime. [\c3Breaking and Entering\c6]", 3);
								%obj.client.CityRP(2, $CityRP::demerits::breakingAndEntering);
							}
							else
							{
								commandToClient(%obj.client, 'centerPrint', "\c6You have commited a crime. [\c3Attempted Breaking and Entering\c6]", 3);
								%obj.client.CityRP(2, $CityRP::demerits::attemptedBnE);
							}
						}
						else
						{
							commandToClient(%obj.client, 'centerPrint', "\c6Picklocking attempt failed", 1);	
						}	
					}
				}
				
				return;
			}
		}
		
		if(%this.canArrest)
		{
			if((%col.getType() & $typeMasks::playerObjectType) && isObject(%col.client))
			{
				if($CityRP::temp::riotCount || $CityRP::temp::riot)
				{
					if($CityRP::temp::riotLeader == %col.client)
					{
						if($CityRP::temp::riot)
						{
							messageAll('', "\c6The hero \c3" @ %obj.client.name @ "\c6 has put an end to criminal scum \c3" @ %col.client.name @ "\c6 and the riot!");
							$CityRP::temp::riot = 0;
							$CityRP::temp::riotCount = 0;
							return;
						}
						else
						{
							messageAll('', "\c6The flames have rebellion have died before they even erupted.");
							$CityRP::temp::riotCount = 0;
							return;
						}
					}
					else if($CityRP::temp::riot)
					{
						messageClient(%obj.client, '', "\c6The only person who can be arrested is \c3" @ $CityRP::temp::riotLeader.name @ "\c6!");
						return;
					}
				}
				
				if(CityRPData.getData(%col.client.bl_id).valueDemerits < $CityRP::pref::demerits::wantedLevel && !getWord(CityRPData.getData(%col.client.bl_id).valueJailData, 1) && !CityRPData.getData(%col.client.bl_id).valueDrugs)
				{
					commandToClient(%obj.client, 'centerPrint', "\c6You have commited a crime. [\c3Hitting Innocents\c6]", 1);
					
					%obj.client.CityRP(2, $CityRP::demerits::hittingInnocents);
					
					return;
				}
				else if(CityRPData.getData(%col.client.bl_id).valueDemerits >= $CityRP::pref::demerits::wantedLevel || CityRPData.getData(%col.client.bl_id).valueDrugs)
				{
					if(%col.isMounted() && vectorLen(%col.getObjectMount().getVelocity()) > 10)
					{
							commandToClient(%obj.client, 'CenterPrint', "\c6That vehicle is moving too fast to arrest that passenger!", 3);
					}
					else
					{
						%col.client.CityRP(3, %obj.client);
					}
				}
				
				return;
			}
		}	
	}
	
	function commandToClient(%client, %command, %arg0, %arg1, %arg2, %arg3, %arg4, %arg5, %arg6, %arg7, %arg8, %arg9, %arg10)
	{
		if(strLwr(getTaggedString(%command)) $= strLwr("bottomPrint") && stripMLControlChars(getWord(%arg0, 0)) !$= "Job:")
		{
			if(%client.CityRPPrintSchedule)
			{
				cancel(%client.CityRPPrintSchedule);
				
				%client.CityRPPrintSchedule = "";
			}
			
			if(!mFloor(%arg1))
			{
				return;
			}
			
			if(mFloor(%arg1))
			{
				%client.CityRPPrintSchedule = %client.schedule(%arg1 * 1000, "CityRP", 1);
			}
		}
		
		parent::commandToClient(%client, %command, %arg0, %arg1, %arg2, %arg3, %arg4, %arg5, %arg6, %arg7, %arg8, %arg9, %arg10);
	}
	
	function WheeledVehicleData::onDamage(%this, %obj, %damage)
	{
		parent::onDamage(%this, %obj, %damage);
		
		if(%obj.getDamageLevel() >= %obj.getDatablock().maxDamage)
		{
			if(isObject(%obj.spawnBrick))
			{
				%obj.spawnBrick.onVehicleDestroyed();
			}
		}
	}
	
	function FlyingWheeledVehicleData::onDamage(%this, %obj, %damage)
	{
		parent::onDamage(%this, %obj, %damage);
		
		if(%obj.getDamageLevel() >= %obj.getDatablock().maxDamage)
		{
			if(isObject(%obj.spawnBrick))
			{
				%obj.spawnBrick.onVehicleDestroyed();
			}
		}
	}
	
	function KeyProjectile::onCollision(%this, %obj, %col, %fade, %pos, %normal)
	{
		parent::onCollision(%this, %obj, %col, %fade, %pos, %normal);
		
		if(%col.getDatablock().getClassName() $= "WheeledVehicleData" && mFloor(VectorLen(%col.getvelocity())) == 0)
		{
			if(%col.brickGroup.client.bl_id == %obj.client.bl_id)
			{
				%col.locked = !%col.locked;
				%col.disableMove = %col.locked;
				commandToClient(%obj.client, 'centerPrint', "\c6Your vehicle is now \c3" @ (%col.locked ? "locked" : "unlocked") @ "\c6.", 3);
			}
			else
			{
				commandToClient(%obj.client, 'centerPrint', "\c6The key does not fit, it is not your car", 3);
			}
		}
		
//		if((%col.getType() & $typeMasks::playerObjectType) && isObject(%col.client))
//		{
//			%klr = %obj.client.player;
//			if(getWord(%col.rotation, 3) - 45 < getWord(%klr.rotation, 3) && getWord(%col.rotation, 3) + 45 > getWord(%klr.rotation, 3))
//			{
//				%name = %col.client.name;
//				%col.kill();
//				messageAll('', "\c3" @ %name @ "\c6 just had their spine cracked open by someone's key!");
//			}
//			else
//			{
//				
//			}
//		}
	}
	
	function miniGameCanUse(%this, %item)
	{
		return 1;
	}
	
	// ============================================================
	// Section 5 : Chat Functions/Overloads
	// ============================================================
	function serverCmdmessageSent(%client, %text)
	{
		if(getSubStr(%text, 0, 1) $= "^")
		{
			if(%client.lastCommandSent + 5 > $sim::time)
			{
				messageClient(%client, '', "\c6To prevent command flooding, your message has been blocked. Try again in" SPC mFloor((%client.lastCommandSent + 5) - $sim::time) SPC "seconds.");
				return;
			}
			
			%command = getWord(getSubStr(%text, 1, strLen(%text) - 1), 0);
			%args = getSubStr(%text, strLen(%command) + 2, strLen(%text) - 1);
			
			if(!call("CrpCmd" @ %command, %client, %args))
			{
				messageClient(%client, '', "\c3" @ %command @ "\c6 is not a recognized command.");
			}
			else
			{
				%client.lastCommandSent = $sim::time;
			}
			
			return;
		}
		
		if(isObject(%client.player) && isObject(%client.CityRPTrigger) && isObject(%client.CityRPTrigger.parent) && %client.CityRPTrigger.parent.getDatablock().CityRPBrickType == 2)
		{
			%client.CityRPTrigger.parent.getDatablock().parseData(%client.CityRPTrigger.parent, %client, "", %text);
			
			return;
		}
		
		if(getWord(CityRPData.getData(%client.bl_id).valueJailData, 1) > 0)
		{
			messageClient(%client, '', "\c6You can't talk while in jail.");
			
			return;
		}
		
		parent::serverCmdmessageSent(%client, %text);
	}
	
	function serverCmdteamMessageSent(%client, %text)
	{
		if(%client.minigame $= CityRPMini)
		{
			if(getSubStr(%text, 0, 1) $= "^" || %client.guise)
			{
				serverCmdmessageSent((%client.guise ? %client.guise : %client), %text);
				return;
			}

			for(%i = 0;%i < ClientGroup.getCount();%i++)
			{
				%subClient = ClientGroup.getObject(%i);
				if(CityRPData.getData(%subClient.bl_id).valueJobID == CityRPData.getData(%client.bl_id).valueJobID)
				{
					messageClient(%subClient, '', "\c3[<color:" @ $CityRP::jobs::tmHexColor[CityRPData.getData(%client.bl_id).valueJobID] @ ">" @ $CityRP::jobs::name[CityRPData.getData(%client.bl_id).valueJobID] @ "\c3]" SPC %client.name @ "<color:" @ $CityRP::jobs::tmHexColor[CityRPData.getData(%client.bl_id).valueJobID] @ ">:" SPC %text);
				}
			}
			echo("(" @ $CityRP::jobs::name[CityRPData.getData(%client.bl_id).valueJobID] @ ")" SPC %client.name @ ":" SPC %text);
		}
		else
		{
			parent::serverCmdteamMessageSent(%client, %text);
		}
	}
	
	function serverCmdcreateMiniGame(%client)
	{
		messageClient(%client, '', "I'm afraid I can't let you do that," SPC %client.name @ ".");
		
		return;
	}
	
	function serverCmdleaveMiniGame(%client)
	{
		messageClient(%client, '', "I'm afraid I can't let you do that," SPC %client.name @ ".");
		
		return;
	}
	
	function serverCmddropTool(%client, %toolID)
	{
		if(getWord(CityRPData.getData(%client.bl_id).valueJailData, 1) > 0)
		{
			messageClient(%client, '', "\c6You can't drop tools while in jail.");
			
			return;
		}
		
		parent::serverCmddropTool(%client, %toolID);
	}
	
	function serverCmdsuicide(%client)
	{
		if(getWord(CityRPData.getData(%client.bl_id).valueJailData, 1) > 0)
		{
			messageClient(%client, '', "\c6You can't suicide while in jail.");
			
			return;
		}
		else if(getWord(CityRPData.getData(%client.bl_id).valueJailData, 1) >= $CityRP::pref::demerits::wantedLevel)
		{
			
		}
		
		parent::serverCmdsuicide(%client);
	}
};
activatePackage(CityRP_MainPackage);