// ============================================================
// Project				:	peopleRP
// Author				:	Iban
// Description			:	Server Preferences
// ============================================================
// Table of Contents
// 1. Basic Preferences
// 2. Price Preferences
// 2.1 Weapon Price Preferences
// 3. Tick Preferences
// 4. Demerit Preferences
// 5. Temporary Variables
// 6. Vehicle Preferences
// ============================================================

// ============================================================
// Section 1 : Random Preferences
// ============================================================
$CityRP::pref::demerits::pardonCost = 150;
$CityRP::pref::demerits::demoteLevel = 250;
$CityRP::pref::demerits::wantedLevel = 50;
$CityRP::pref::demerits::reducePerTick = 30;
$CityRP::pref::demerits::minBounty = 200;
$CityRP::pref::demerits::maxBankTheft = 10000;
$CityRP::pref::demerits::demeritCost = 2;
$CityRP::pref::demerits::recordShredCost = 500;
$CityRP::pref::demerits::irsBustsYourBalls = 3;
$CityRP::pref::demerits::irsBounty = 200;

$CityRP::pref::resources::tree::regrowTime = 2.5;
$CityRP::pref::resources::ore::noOreColorID = 56;
$CityRP::pref::resources::ore::hasOreColorID = 55;

$CityRP::pref::realestate::maxLots = 5;

$CityRP::pref::giveDefaultTools = true;
$CityRP::pref::defaultTools = "hammerItem printGun wrenchItem";

// ============================================================
// Section 2 : Price Preferences
// ============================================================
$CityRP::prices::vehicleSpawn = 500;
$CityRP::prices::addItemSpawn = 25;
$CityRP::prices::jailingBonus = 15;
$CityRP::prices::reset = 1000;
$CityRP::prices::resourcePrice = 0.5;
$CityRP::prices::drugsMin = "2";
$CityRP::prices::drugsMax = "5";

// Section 2.1 - Weapon Prices

// There is an algorithm in the code that determines the price of an object.
// The sequence can be faulty, to say the least.
// If you would like to enter in your own price for an item, simply add this line:
// $CityRP::prices::weapon["weaponImageName"] = customPrice;
// Entering in the value of "noSale" instead of a number will disable the purchase of this item.
// Any weapons that do not have a custom price will get priced by the algorithm.
// If you would like all non-priced items to not be spawned or priced, turn this variable to false:
$CityRP::prices::weapon::priceAlgorithm = false;

$CityRP::prices::weapon["keyImage"] = 5;
$CityRP::prices::weapon["taserImage"] = 25;
$CityRP::prices::weapon["gunImage"] = 50;
$CityRP::prices::weapon["akimboGunImage"] = 75;
$CityRP::prices::weapon["CityRPTaserImage"] = 75;
$CityRP::prices::weapon["shotgunImage"] = 100;
$CityRP::prices::weapon["rocketLauncherImage"] = 125;
$CityRP::prices::weapon["sniperRifleImage"] = 150;
$CityRP::prices::weapon["minigunImage"] = 175;


// ============================================================
// Section 3 : Tick Preferences
// ============================================================
$CityRP::tick::interest = 1.01;
$CityRP::tick::interestTick = 12;
$CityRP::tick::speed = 5;
$CityRP::tick::promotionLevel = 24;

// ============================================================
// Section 4 : Demerit Preferences
// ============================================================
$CityRP::demerits::hittingInnocents = 10;
$CityRP::demerits::attemptedMurder = 25;
$CityRP::demerits::murder = 75;
$CityRP::demerits::breakingAndEntering = 10;
$CityRP::demerits::attemptedBnE = 5;
$CityRP::demerits::bountyPlacing = 25;
$CityRP::demerits::bountyClaiming = 65;
$CityRP::demerits::pickpocketing = 25;
$CityRP::demerits::bankRobbery = 3000;
$CityRP::demerits::tasingBros = 25;
$CityRP::demerits::demsPerDrugUnit = 3;

// ============================================================
// Section 5 : Vehicle Preferences
// ============================================================
$CityRP::vehicles::allowSpawn = true;

$CityRP::vehicles::banned[0] = "FlyingWheeledJeepVehicle";
$CityRP::vehicles::banned[1] = "MiniJetVehicle";
$CityRP::vehicles::banned[2] = "StuntPlaneVehicle";
$CityRP::vehicles::banned[3] = "BiplaneVehicle";
$CityRP::vehicles::banned[4] = "MagicCarpetVehicle";
$CityRP::vehicles::banned[5] = "TankVehicle";

export("$CityRP::*", "config/server/IbanMod/CityRPG/Prefs.cs");