// ============================================================
// Project				:	CityRP
// Author				:	Iban
// Description			:	Lumberjack Axe Code File
// ============================================================
// Table of Contents
// 1. Weapon Data
// 1.1. Datablocks
// 1.2. Visual Functionality
// ============================================================

// ============================================================
// Section 1 : Weapon Data
// ============================================================

// Secton 2.1 : Datablocks
datablock projectileData(CityRPLumberjackProjectile : swordProjectile)
{
	directDamage = 0;
	lifeTime = 100;
	explodeOnDeath = false;
};

datablock itemData(CityRPLumberjackItem : swordItem)
{
	uiName = "Lumberjack Axe";
	noSpawn = true;
	image = CityRPLumberjackImage;
	shapeFile = "Add-Ons/GameMode_CityRPG/shapes/lumberjack.1.dts";
};

datablock shapeBaseImageData(CityRPLumberjackImage : swordImage)
{
	item = CiyRPLumberjackItem;
	shapeFile = "Add-Ons/GameMode_CityRPG/shapes/lumberjack.1.dts";
	projectile = CityRPLumberjackProjectile;
};

// Section 2.2 : Visual Functionality
function CityRPLumberjackImage::onFire(%this, %obj, %slot)
{
	parent::onFire(%this, %obj, %slot);
	
	%obj.playThread(2, "armAttack");
}

function CityRPLumberjackImage::onStopFire(%this, %obj, %slot)
{
	%obj.playThread(2, "root");
}